/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doenv.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doenv.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>
#include <fcntl.h>
#include <string.h>

#ifdef DOS
#include <process.h>
#include <io.h>
#include <conio.h>
#include <ctype.h>
#else
#include <termio.h>
#include <unistd.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "doerror.h"
#include "dostring.h"
#include "doscr.h"
#include "domem.h"
#include "doregex.h"
#include "dolib.h"
#include "docfg.h"
#include "doenv.h"

#define VAR_NAME	256
#define VAR_CONT	MAXPATH

frame_T env_f;
char *  env_var;
char *  env_cont;
input_T env_in;

void view_env (int pos)
{
  char * env_value = getenv (env_var);
  if (env_value == NULL) env_value = "<No value>";
  else
    {
      if (strlen (env_cont) == 0) strcpy (env_cont, env_value);
    }
  f_putstr (env_f, 16, 5, env_value, env_f->color, SCR_MODE|FILL_MODE);
}

void environment (void)
{
  frame_T f;
  input_T in;
  log_T   lg;
  char
    var_name [VAR_NAME] = {0},
    var_cont [VAR_CONT] = {0},
    * var_desc [] = {   " Environment: ",
			" Content....: ", 
			" Value......: "},
    hlp_text [] = " Enter your environment ... ";
  short
    i,
    j,
    lk,
    width = max_x - 10,
    down  = 9,
    x     = (max_x - width) / 2,
    y     = (max_y - down ) / 2;

  f = make_frame (x, y, width, down, " Set/Unset Environment ", leer,
		  F_B_UTIL_CLR,
		  NOMODE);
  in = make_input (f, 3, CUR_MODE | FIL_MODE | INS_MODE);
  input_help (in, hlp_text);
  lg = make_log   (f, 2, F_B_UTIL_CHS);

  env_f    = f;
  env_var  = var_name;
  env_cont = var_cont;
  env_in   = in;

  log_format      (lg, var_desc[0], var_desc[1]);
  i  = f->width/2;
  log_xy          (lg,
		   (i - strlen (var_desc[0])) / 2,     f->down,
		   i + (i - strlen (var_desc[1])) / 2, f->down
		   );

  input_string (in, 0, 15, 1, var_name, VAR_NAME-2, VAR_NAME-2);
  input_string (in, 1, 15, 3, var_cont, VAR_CONT-2, VAR_CONT-2);
  input_log    (in, 2, lg);

  for (i=0; i<3; i++)
    {
      f_putstr (f, 1, 1+i*2, var_desc [i],  f->color, NOMODE);
    }
  f_putline (f, 2, f->color);
  f_putline (f, 4, f->color);
  f_putline (f, 6, f->color);

  in->prog = view_env;
  view_frame (f);
  lk = f_getstr   (in);

  if ((lk == ENTER || lk == CTRL_M) && strlen (env_var) > 0)
    {
      char tmp [VAR_NAME+VAR_CONT+1];
      sprintf (tmp, "%s=%s", var_name, var_cont);
      if (putenv  (tmp))
	{
	  message (" Unable to set the new environment variable ", 
		   " Environment seting ");
	}
    }

  hide_frame (f, HIDE_MODE|DELETE_MODE);
  del_input  (in);
  del_log    (lg);
}

