/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dofiles.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dofiles.h,v $
 */

/****************************************************************************/
/**                  							   **/
/****************************************************************************/

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOFILES_HH
#	define DOFILES_HH

#include "dodefs.h"

#define EXEC_FILE	0x0001
#define DATA_FILE	0x0002
#define TEXT_FILE	0x0004
#define DIR_SYMLINK	0x0002

#define get_rights() (~ get_umask (FALSE) & 0777)

int 	exist		( char * file);
int 	is_dir		( char * dr,   int mode);
int 	is_file		( char * file, int mode);
int 	file_owner	( char * file);
int 	file_grp	( char * file);
long 	file_size	( char * file, int mode);
long	file_size_count ( char * file, int * files, int * dirs, 
			  struct frame_t * fr, 
			  int mode);
int 	can_write	( char * file);
int 	can_read	( char * file);
int     can_exec	( char * file);
unsigned short get_stat	( char * file);
int 	get_umask	( int mode);
int 	create_dir	( char * dr, int mode);

char * 	getfile		( void);

GLOBAL long file_goto	( long size, long akt_pos);
GLOBAL int  file_type   ( char * file);

#endif /*_HH*/
