/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dohexa.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dohexa.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOHEXA_HH
#	define DOHEXA_HH

#include "doframe.h"

#define FINDLEN 120              /* for commmand file_findtext */
#define COUNT_LINES	0x0002	 /* return count of moved lines in file */

/*
 * Macros for the Parameter to Procedur "hexa_editor"
 */
#define HEXA_VIEW_MODE	0x0001
#define HEXA_EDIT_MODE	0x0002

GLOBAL char hexa_search [FINDLEN+1];     /* string to search for text */ 
GLOBAL long file_findstr   (struct frame_t * f,
			    int file_h,
			    char * str,
			    int mode);
GLOBAL long file_findtext  (int file_h, char * str, int mode);
GLOBAL void hexa_editor    ( char * exe_file, int mode);

#endif /*_HH*/
