/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: domath.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/domath.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "domath.h"

long MY_atol (char * str)
{
  int len = strlen (str), i;
  long fak = 1, sum = 0;
  for (i=len-1; i>=0; i--)
    {
      if (str [i] >= '0' && str [i] <= '9')
	{
	  sum += (str [i] - '0') * fak;	/* faktor = 1, 10, 100, 1000, .. */
	}
      else if (i == 0 && (str [i] == '-' || str [i] == '+'))  /* +/-1234.. */
	{
	  if (str [i] == '-') sum = sum * -1;		/* minus value */
	}
      else
	{
	   return 0;				/* error */
	}
      fak = fak * 10;
   }
  return sum;
}

#ifdef TEST_MATH
main ()
{
  char buf [30];
  while (1)
  {
    scanf ("%s", buf);
    printf ("%s MY = %li, atoi = %li\n", buf, MY_atoi (buf), atoi (buf));
    if ( strcmp (buf, "quit") == 0) exit (0);
  }
}
#endif
