/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doscr.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doscr.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOSCR_HH
#	define DOSCR_HH

#define F_B_NORMAL 	MY_cfg.colors[ 0]        /* normal color */
#define F_B_CHOOSE_CLR 	MY_cfg.colors[ 1]        /* choose color */

#define F_B_SELECT_CLR 	MY_cfg.colors[ 2]        /* select color */
#define F_B_SELECT_CHS 	MY_cfg.colors[ 3]        /* choose select color */

#define F_B_MENU_CHS 	MY_cfg.colors[ 4]        /* choose color for menu */
#define F_B_MENU_CLR 	MY_cfg.colors[ 5]        /* normal color for menu */

#define F_B_DIALOG_CLR 	MY_cfg.colors[ 6]        /* color for message normal color */
#define F_B_DIALOG_CHS 	MY_cfg.colors[ 7]        /* message color choose */

#define F_B_UTIL_CHS 	MY_cfg.colors[ 8]        /* Utilities frame color  */
#define F_B_UTIL_CLR 	MY_cfg.colors[ 9]        /* Choose in utilities frame color  */

#define F_B_HELP_CLR 	MY_cfg.colors[10]
#define F_B_HELP_CHS 	MY_cfg.colors[11]

#define F_B_HELPLINE_CLR MY_cfg.colors[12]       /* help line for key functions */

#define F_B_BLOCK_CLR 	MY_cfg.colors[13]        /* editor block color */

#define F_B_INPUT_CLR 	MY_cfg.colors[14]        /* INPUT  color */
#define F_B_INPUT_CHS 	MY_cfg.colors[15]        /* string color for first call */

#define F_B_TITLE_CLR 	MY_cfg.colors[16]  /* title color for all frames */

#define F_B_HEAD_CLR 	MY_cfg.colors[17]  /* for copyrights */

#define F_B_INSMODE_CLR MY_cfg.colors[18]  /* insert/overwrite mode color */

#define F_B_CLOCK_CLR 	MY_cfg.colors[19]  /* clock colrs */
#define F_B_COMLINE_CLR MY_cfg.colors[20]  /* command line color */
#define F_B_GROUND_CLR  MY_cfg.colors[21]	/* normal color */
#define F_B_SCROLL_CLR	MY_cfg.colors[22]	/* color for scroller */

#define CLR_CNT		23

GLOBAL char get_videomode	( void);
GLOBAL void set_videomode	( char m);
GLOBAL int  get_max_x  		( int video_mode);
GLOBAL int  get_max_y  		( int video_mode);
GLOBAL int  get_seg   		( int video_mode);
GLOBAL int  get_scr_info	( int video_mode, int mode);
GLOBAL void change_colors      	( void);
GLOBAL void set_colors        	( void);
GLOBAL void get_screen          ( void);          /* save screen in buffer */
GLOBAL void put_screen          ( void);          /* restore screen */

#endif /*_HH*/
