/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dotext.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/dotext.h,v $
 */

#ifndef GLOBAL
#define GLOBAL
#endif

#ifndef DOTEXT_HH
#	define DOTEXT_HH

#ifdef EXTERN
GLOBAL char
    * week[],
    * month[],
    * hlp_txt[],
    * options[],
    * opt_txt[],
    * cont_break[],
    * ok_       [],
    * cpyright  [],
    * use_hlp   [];
#else
GLOBAL char
    * week[]  = {
      		  "Su", "Mo", "Tu", "We",
		  "Th", "Fr", "Sa"
		},
    * month[] = {
		  "Jan", "Feb", "Mar", "Apr",
		  "May", "Jun", "Jul", "Aug",
		  "Sep", "Oct", "Nov", "Dec"
		},
    * hlp_txt[] = {
        "",
	"khfm UNIX & DOS Version 1.0, CopyRight 1994-1997",
	"",
#ifdef DOS
	"********************************************************************",
	"***  the termcap describtion and others are only for UNIX        ***",
	"********************************************************************",
	"",
#endif
	"",
	"absolutely no warrantly                          absolut keine Haftung",
	"",
	"",
	"F10       : call the m\bme\ben\bnu\bu",
	"",
	"F1,Ctrl-P : h\bhe\bel\blp\bp",
	"",
	"            call this help",
	"",
/*	"Portability: conformant with All UNIX Standards i386 (AT&T) ", */
	"P\bPo\bor\brt\bta\bab\bbi\bil\bli\bit\bty\by: conformant with All UNIX Standards i386 (AT&T) ",
	"            It is linked under SCO unix 3.2 i386",
	"",
/*	"F3,Ctrl-L : long/short list", */
	"F3,Ctrl-L : l\blo\bon\bng\bg/s\bsh\bho\bor\brt\bt list",
	"",
	"            by 'long view' you can use CURSOR-RIGHT/LEFT to view",
	"            the part of file informations you want to see.",
	"            the informations in the long list are given as following:",
	"",
	"            size | minor & major, modify time, owner, group, rights,",
	"            inode, links, create time and assecc time.",
	"",
	"            When you are in a wide window you can see the most",
	"            informations of the long list.",
	"",
	"F6,Ctrl-O : S\bSo\bor\brt\bt m\bme\bet\bth\bho\bod\bde\be",
	"",
	"            you have a long list of sort criterions you can choose.",
	"            only for 'name'-sort methode it is very fast, then the",
	"            stat-command for reading file informations is under UNIX",
	"            not the fastest and it takes for directories with mutch",
	"            entries more time as normal but it is very nice to have",
	"            all the file informations as sort creterions.",
	"            every sort methode can given as ascending/descinding list.",
	"            when you call this command, the block-choose is given",
	"            on the current sort methode.",
	"",
	"F5,Ctrl_Z : s\bse\bel\ble\bec\bct\bt/u\bun\bns\bse\bel\ble\bec\bct\bt the current file and go to the next file",
	"",
	"            the selected files are given in another color.",
	"            you cann't select the entries <<'.' & '..'>>.",
	"",
	"Ctrl_K    : require you to give the files you want to s\bse\bel\ble\bec\bct\bt.",
	"",
	"            it uses the 'regex' functions ",
	"",
	"Ctrl-U    : the same as Ctrl-K but it u\bun\bns\bse\bel\ble\bec\bct\bts\bs the files in the",
	"            given list.",
	"",
/*	"Ctrl-W    : choose files", */
	"Ctrl-W    : c\bch\bho\boo\bos\bse\be f\bfi\bil\ble\bes\bs",
	"",
	"            only the found files are given in the window.",
	"            it uses the 'regex' functions",
	"",
/*	"Ctrl-A    : directories", */
	"Ctrl-A    : d\bdi\bir\bre\bec\bct\bto\bor\bri\bie\bes\bs",
	"",
	"            view only the directories in the current work directory.",
	"            but you can sort the entries in your current windows",
	"            with the 'directories first'-sort methode and you have",
	"            better outline on the direcotry entries.",
	"",
/*	"Ctrl-G    : select work window", */
	"Ctrl-G    : select w\bwo\bor\brk\bk w\bwi\bin\bnd\bdo\bow\bw",
	"",
	"            you see a list of all windows you have with the current",
	"            path and you can choose direct the requested window.",
	"",
/*	"F7,Ctrl-X : command line in <edit mode>", */
	"F7,Ctrl-X : command line in <e\bed\bdi\bit\bt m\bmo\bod\bde\be>",
	"",
	"            in this mode you can use the move-cursors to ramble into",
	"            your command line.",
	"            with PageUp/Down you can call the 'command history'",
	"            and choose any command line.",
	"            every with ENTER picked command is saved in the",
	"            history file <.dirhistory> in your HOME-Directory.",
	"",
/*	"Ctrl-V    : view any file ",*/
	"Ctrl-V    : v\bvi\bie\bew\bw a\ban\bny\by f\bfi\bil\ble\be ",
	"",
/*	"            This Viewer is as extra utility named 'khview' to call too.", */
	"            This Viewer is as extra utility named 'k\bkh\bhv\bvi\bie\bew\bw' to call",
	"            from the command line.",
	"",
	"            it pipe the input, when you don't give any arguments",
	"            on the call command line.",
	"",
	"            you can view only text-files. for another files you can",
	"            use the hexa editor <Ctrl-T> or 'khhexa'.",
	"            This viewer is very usefull for formatted files and the",
	"            (man)-command as pager.",
	"            The underlined lines are viewed in another color.",
	"            As example: <termcap> ==> <t\bte\ber\brm\bmc\bca\bap\bp>.",
	"            call      : man -pkhview <name>.",
	"            or change the default pager in the '/etc/default/man'-file",
	"            to 'khview'",
	"",
/*	"F2        : create a new directory", */
	"F2        : c\bcr\bre\bea\bat\bte\be a\ba n\bne\bew\bw d\bdi\bir\bre\bec\bct\bto\bor\bry\by",
	"",
/*	"F4,Ctrl-Y : copy current/selected file(s).", */
	"F4,Ctrl-Y : c\bco\bop\bpy\by c\bco\bom\bmm\bma\ban\bnd\bd",
	"",
	"            It asks you to copy current/selected file(s).",
	"            You have in this command many flags: ",
	"               1. recursive: copy directories with there entries.",
	"               2. same rightes: set the rights as in the source file",
	"                  otherwise it set the rights from 'umask'",
	"               3. same user: the same user from source file is seted",
	"                             for the new file (id. with chown).",
	"               4. same group: same group from source is seted for",
	"                              the new file (id. with chgrp).",
	"                  otherwise the current user/group are seted",
	"               5. filter: you can give any existing program to pipe",
	"                          the files into copying.",
	"                  example: 'unix2dos'",
/*	"                  the Filter must accept the 'EOF' to signal his termination",*/
	"                  the Filter must accept the 'E\bEO\bEF\bF' to signal his termination",
	"",
	"            - If there are selected files this command copy only this",
	"              files otherwise it copy the current file/directory.",
	"            - selected files can copied only to directories. if it isn't",
	"              any directory, a new directory is created.",
	"",
/*	"F9,Ctrl-R : Remove current/selected file(s)", */
	"F9,Ctrl-R : R\bRe\bem\bmo\bov\bve\be current/selected file(s)",
	"",
	"            it removes the current/selected file(s).",
	"            not empty directories can you delete recursive,",
	"            when you choose the recusive flag.",
	"   W\bWA\bAR\bRN\bNI\bIN\bNG\bG: recursive flag on selected directories delete all there",
	"            entries. No undo is possible.",
	"        <<  but the recursive remove is very good to use  >>",
	"            every removed file is given on the screen.",
	"",
/*	"Notice: When you don't use 'lstat'-procedure, you must be carefull by",
	"            symbolic links of directories.", */
/*	"            So that you can call a recursive copy/remove of the same directory", */
/*	"            into it self.", */
	"N\bNo\bot\bti\bic\bce\be: When you don't use 'lstat' -procedure, you must be carefull",
	"            by s\bsy\bym\bmb\bbo\bol\bli\bic\bc l\bli\bin\bnk\bks\bs of directories.",
	"            So that you can call a r\bre\bec\bcu\bur\brs\bsi\biv\bve\be copy/remove of the same directory",
	"            into it self.",
	"            The utility doesn't test the files for any links, to be",
	"            compatible with all UNIX-companies.",
	"",
/*	"F8,Ctrl-E : Edit current file", */
	"F8,Ctrl-E : E\bEd\bdi\bit\bt current file",
	"",
/*	"            You can call this utility extra as program named 'khedit'",*/
	"            You can call this utility extra as program named 'k\bkh\bhe\bed\bdi\bit\bt'",
	"            from the command line.",
	"",
	"            it calls a simple editor.",
	"            this editor is very easy to work with (DOS-easy).",
	"            All functions of this editor are described in the menu",
	"            when you call from the editor with 'F10'.",
	"",
/*	"Ctrl-T    : Hexa Editor", */
	"Ctrl-T    : H\bHe\bex\bxa\ba E\bEd\bdi\bit\bto\bor\br",
	"",
/*	"            You can call this utility extra as program named 'khhexa'",*/
	"            You can call this utility extra as program named 'k\bkh\bhh\bhe\bex\bxa\ba'",
	"",
	"            It is a professional Hexa Editor to edit executable files",
	"            the source file is copied to a temporary file. File is only saved",
	"            when you require to save.",
	"            functions and commands are listed in the menu (F10).",
	"            You can search (hexa) with (F4).",
	"",
/*	"Electric communication:",*/
	"E\bEl\ble\bec\bct\btr\bri\bic\bc c\bco\bom\bmm\bmu\bun\bni\bic\bca\bat\bti\bio\bon\bn:",
	"",
	"            you can call this utility extra with 'khmsg' from the",
	"            command line.",
	"",
	"            it is an interactive communication system.",
	"            with this command you can communicate with everyone",
	"            on the system.",
	"            It calls the (who -u) command to list all users loged",
	"            on the system.",
	"            When you choose an user the program try to send a message",
	"            on the user-terminal (when mesg is set).",
	"            When the reciver have a Khamis Utility runing he will get",
	"            a message anywhere and the communication can begin.",
	"            Otherwise he must run any Khamis Utility to communicate",
	"            with you.",
	"",
	/*	change mode */
	"C\bCh\bha\ban\bng\bge\be m\bmo\bod\bde\be: of current/selected file(s).",
	"",
	"            you can call this command only from menu with F10.",
	"            It changes the mode of current/selected files.",
	"            you can use the recursive flag to set the mode for all",
	"            directory entries in the selected list.",
	"",
	/*	change owner/group */
	"C\bCh\bha\ban\bng\bge\be o\bow\bwn\bne\ber\br/g\bgr\bro\bou\bup\bp: of the current/selected files",
	"",
	"            it works same as 'change mode' command.",
	"            it sets a new owner/group for current/selected files.",
	"            on the input frame for a new user/group you can call ",
	"            a LIST for ALL users/groups on the system with",
	"            Page-Down.",
	"",
/*	"Search: <this command called only from menu>",*/
	"S\bSe\bea\bar\brc\bch\bh:",
	"",
	"            It calls a recursive self implemented procedure,",
	"",
/*	"Grep: <this command called only from menu>",*/
	"G\bGr\bre\bep\bp: <this command called from menu>",
	"            this utility calls the UNIX-'grep' command and pipes",
	"            the output to a scrollbar list, so that you can choose",
	"            any file and pick to it in its directory, only if the",
	"            line format like [\b[ <file>:<found line> ]\b].",
	"",
/*	"            Under DOS it call a recursive self implemented procedure,", */
	"            Under D\bDO\bOS\bS it calls a recursive self implemented procedure,",
	"            it uses the DOS-pattern-matching <?*.*,..> and it makes",
	"            the same output as the 'grep'-command.",
	"",
	"Tree Manager:",
	"            It calls a simple tree manager to view the entries in a",
	"            given path, you can view the files on the tree too.",
	"            It changes to the selected path when you pick any entry.",
	"",
	"Ctrl-F    : S\bSe\bea\bar\brc\bch\bhs\bs for given file in the current directory and",
	"            moves the scroll-block to it.",
	"",
	"TAB/BACK-T: change to n\bne\bex\bxt\bt/p\bpr\bre\bev\bv window, if there are more windows",
	"            available.",
	"",
/*	"Home,End  : move the block-choose to the first/last file.", */
	"H\bHo\bom\bme\be,E\bEn\bnd\bd  : move the block-choose to the first/last file.",
	"            On string input move the cursor to begin/end of",
	"            the string",
	"",
	"Ctrl-C    : asks to e\bex\bxi\bit\bt",
	"",
	"exit      : exit without question.",
	"            you must give 'e\bex\bxi\bit\bt' on the command line and press ENTER.",
	"",
	"String input functions on the input line for strings:",
	"            when you on an input field to input any string-text,",
	"            you can use the move-keys and the editor commands:",
	"            Ctrl-W: next word on the line",
	"            Ctrl-T: prev. word on the line",
        "            Ctrl-R: remove the next word on the current line",
	"",
	"the follow functions called only when you have activeted the command",
	"            line (Ctrl-X) in the 'edit-mode':",
	"            TAB   : print the current file into the string",
	"            Ctrl-F: print the current file with './' into the string",
	"                    on current position",
        "            Cr-Up : prev. command from history",
	"            Cr-Dn : next command from history",
	"            Pg-Up/Dn: H\bHi\bis\bst\bto\bor\bry\by list for all called commands, that",
	"                    you can choose your command direct from file.",
        "",
	"For more functions and utilieties you can see in the menu with (F10).",
	"",
/*	"TERMCAP-file:", */
	"T\bTE\bER\bRM\bMC\bCA\bAP\bP-file:",
	"",
	"the termcap file is defined in the environment variable named",
/*	"'TERMCAP' (with full pathname).",*/
	"'TERMCAP' (with full p\bpa\bat\bth\bhn\bna\bam\bme\be).",
	"If this variable is not seted, the termcap informations",
	"are getting from the default '/etc/termcap' file. But you need more",
	"Informations for your aktual Terminal type. the default informations",
	"in the default '/etc/termcap' are not enough to run this program.",
	"You need the following TERMCAP-entries:",
	"the entries are for standard ansi terminals as example to see.",
	"       :GS=^[[12m:       # graphic mode on",
	"       :GE=^[[10m:       # graphic mode off",
	"       :G1=;:            # corner oben-right",
	"       :G2=I:            # corner open-left",
	"       :G3=H:            # corner buttom-left",
	"       :G4=<:            # corner buttom-right",
	"       :GV=\\72:          # vertical line",
	"       :GH=M:            # horizontal line",
	"       :GL=9:            # corner open-buttom-left",
	"       :GR=L:            # corner open-buttom-right",
	"       :cm=^[[%i%d;%dH:  # x-y-coordinates (gotoxy)",
	"       :md=^[[1m:        # color mode <high_white>",
/*
	"       :mb=^[[5m:        # blanking",
	"       :me=^[[m:         # set normal attribute",
	"       :so=^[[7m:        # inverse",
*/
	"       :kb=^h:           # backspace",
	"       :co#80:           # columns on the screen",
	"       :li#25:           # lines on the screen",
	"       :cl=^[[2J:        # clear screen",
	"       :dl=^[[M:         # delete line",
	"       :CF=^[[=16;16C:   # hide cursor",
	"       :CN=^[[=10;12C:   # view cursor",
	"       :ce=^[[K:         # delete to end of line",
	"the keys, there are used in the programm:",
	"       :bt=^[[Z^[[Z      # backtab",
	"       :k1=^[[M:         # F1",
	"       :k2=^[[N:         # F2",
	"       :k3=^[[O:         # F3",
	"       :k4=^[[P:         # F4",
	"       :k5=^[[Q:         # F5",
	"       :k6=^[[R:         # F6",
	"       :k7=^[[S:         # F7",
	"       :k8=^[[T:         # F8",
	"       :k9=^[[U:         # F9",
	"       :k0=^[[V:         # F10",
	"       :ku=^[[A:         # Cursor up",
	"       :kd=^[[B:         # Cursor down",
	"       :kl=^[[D:         # Cursor left",
	"       :kr=^[[C:         # Cursor right",
	"       :PU=^[[I:         # Page up",
	"       :PD=^[[G:         # Page down",
	"       :EN=^[[F:         # End",
	"       :IN=^[[L:         # Insert",
	"       :HM=^[[H:         # Home",
	"       :RM=\\177:         # delete character",
/*	"       :ESC=^[[X:        # user defined EXIT/ABORT-key (like F12)", */
	"       :E\bES\bSC\bC=^[[X:        # user defined EXIT/ABORT-key (like F12)",
	"                         # this key must be defined to work successfull",
/*	"       :ESC-a=^[a:       # ESC a     ", */
	"       :E\bES\bSC\bC-\b-a\ba=^[a:       # ESC a     ",
	"       :ESC-b=^[b:       # ESC b     ",
	"          ..   ..          ..  ..    ",
	"          ..   ..          ..  ..    ",
	"       :ESC-y=^[y:       # ESC y     ",
	"       :ESC-z=^[z:       # ESC z     ",
	"       :ESC-A=^[A:       # ESC A     ",
	"       :ESC-B=^[B:       # ESC B     ",
	"          ..   ..          ..  ..    ",
	"          ..   ..          ..  ..    ",
	"       :ESC-Y=^[Y:       # ESC Y     ",
/*	"       :ESC-Z=^[Z:       # ESC Z     ", */
	"       :E\bES\bSC\bC-\b-Z\bZ=^[Z:       # ESC Z     ",
	"the following definitions are for colors",
	"       for every color you must define the forground/background",
	"       colors and the sequences to set the colors on/off:",
	"",
/*	"       :color name=forgrnd on:forgrnd off:backgrnd on:backgrnd off:",*/
	"       :c\bco\bol\blo\bor\br n\bna\bam\bme\be=forgrnd o\bon\bn:forgrnd o\bof\bff\bf:backgrnd o\bon\bn:backgrnd o\bof\bff\bf:",
	"",
/*	"       :black=^[[30m:^[[37m:^[[40m:^[[40m:",*/
	"       :b\bbl\bla\bac\bck\bk=^[[30m:^[[37m:^[[40m:^[[40m:",

/*	"       :white=^[[37m:^[[37m:^[[47m:^[[40m:",*/
	"       :w\bwh\bhi\bit\bte\be=^[[37m:^[[37m:^[[47m:^[[40m:",

/*	"       :red=^[[31m:^[[37m:^[[41m:^[[40m:",*/
	"       :r\bre\bed\bd=^[[31m:^[[37m:^[[41m:^[[40m:",

/*	"       :green=^[[32m:^[[37m:^[[42m:^[[40m:",*/
	"       :g\bgr\bre\bee\ben\bn=^[[32m:^[[37m:^[[42m:^[[40m:",

/*	"       :yellow=^[[33m:^[[37m:^[[43m:^[[40m:",*/
	"       :y\bye\bel\bll\blo\bow\bw=^[[33m:^[[37m:^[[43m:^[[40m:",

/*	"       :brown=::::",*/
	"       :b\bbr\bro\bow\bwn\bn=::::                       # not availiable",
/*	"       :blue=^[[34m:^[[37m:^[[44m:^[[40m:",*/
	"       :b\bbl\blu\bue\be=^[[34m:^[[37m:^[[44m:^[[40m:",

/*	"       :violet=^[[35m:^[[37m:^[[45m:^[[40m:",*/
	"       :v\bvi\bio\bol\ble\bet\bt=^[[35m:^[[37m:^[[45m:^[[40m:",

/*	"       :cyan=^[[36m:^[[37m:^[[46m:^[[40m:",*/
	"       :c\bcy\bya\ban\bn=^[[36m:^[[37m:^[[46m:^[[40m:",
	"",
	"       The following colors are for monochrome terminals to use",
	"       This colors are loaded by option <\b<-nocolor>\b> ",
	"       This example is for [TERM=vt220]:",
	"",
/*	"       :normal=^[[0m:^[[0m:^[[0m:^[[0m:", */
	"       :n\bno\bor\brm\bma\bal\bl=^[[0m:^[[0m:^[[0m:^[[0m:",
/*	"       :input=^[[1m:^[[0m:^[[1m:^[[0m:",*/
	"       :i\bin\bnp\bpu\but\bt=^[[1m:^[[0m:^[[1m:^[[0m:",
/*	"       :message=^[[7m:^[[0m:^[[7m:^[[0m:",*/
	"       :m\bme\bes\bss\bsa\bag\bge\be=^[[7m:^[[0m:^[[7m:^[[0m:",
/*	"       :underlined=^[[4m:^[[0m:^[[4m:^[[0m:",*/
	"       :u\bun\bnd\bde\ber\brl\bli\bin\bne\bed\bd=^[[1m^[[4m:^[[0m:^[[1m^[[4m:^[[0m:",
	"",
	"       more colors are not accepted",
	"",
/*	"Notice:  for monochrome Terminals you have only absolute color",*/
	"N\bNo\bot\bti\bic\bce\be:  for m\bmo\bon\bno\boc\bch\bhr\bro\bom\bme\be Terminals you have only absolute color",
	"         sets. for-/background colors are not existing.",

/*	"         *** Use the same color set for for-/background and define your ***",*/
	"         *** Use the s\bsa\bam\bme\be color set for for-/background and define your ***",

	"         *** colors with the color definition program called from the   ***",

/*	"         *** menu under 'options' and give for for-/background the same ***",*/
	"         *** menu under 'o\bop\bpt\bti\bio\bon\bns\bs' and give for for-/background the same ***",

	"         *** colors, then you can save your setup and the color set is  ***",
	"         *** loaded by the next call.                                   ***",
	"",
	"         But when you use the option <\b<-nocolor>\b> you well have the same effect.",
	"",
/*	"Notice:  when you have problems with the graphic part you can disable", */
	"N\bNo\bot\bti\bic\bce\be:  when you have problems with the graphic part you can disable",
	"         the graphic characters and give for it ASCII-characters",
	"         like: '|\b|' for GV, '-\b-' for GH and '+\b+' for corners.",
	"         But you don't give any ESC-combination for GE and GS.",
	"         as example a line will be see like:",
	"              GE=:GS=:GV=|:GH=-:G1=+:G2=+:G3=+:G4=+:\\",
	"",
	"",
/*      none printable characters */
	"N\bNo\bot\bti\bic\bce\be: N\bNo\bon\bne\be p\bpr\bri\bin\bnt\bta\bab\bbl\ble\be characters are printed as ``~\b~''.",
	"",
	"My english: is not the best and I'm sory if I have writing any ",
	"            rong english.",
	"",
	"FILES:",
	"lib/khfm/termcap",
	"",
	NULL
	};

#include "doabout.h"

GLOBAL char * use_hlp [] = {
	 "OPTIONS: ",
	 "  [ -p   file] : parameter file",
	 "  [ -c   file] : load another config-file as the default named '$TERM.cfg'",
	 "                 option only on the command line accepted",
	 "  [ -nocolor ] : load another combination of colors",

#ifdef MOUSE
	 "  [ -usemouse] : enable the mouse",
#endif

	 "  [ -files 999] : Max. Files can readed in the window",
	 "  [ -h     99 ] : maximal history-stack length",
	 "  [ -win   99 ] : the count of work windows (max. 10)",
	 "  [ -w     99 ] : set next values for window number # (def. is 1)",
	 "  [ -x     99 ] : x-coordinate of current window",
	 "  [ -y     99 ] : y-coordinate of current window",
	 "  [ -width 99 ] : width of current window",
	 "  [ -down  99 ] : down lines of of current window",
	 NULL
	 },
#ifdef UNIX
    * options[] = {
      		    "/usr/bin/sh",
      		    ".dirhistory",		/* history file */
		    "/dev/null",
		    "900",
		    NULL
		  },
#else
    * options[] =  {
      		     "command.com",
                     "c:\\history.dir",		/* history file */
		     "c:\\khdir.tmp",
		     "900",
		     NULL
		   },
#endif
    * opt_txt [] = {
      		     "Shell        :",
      		     "History file :",
		     "Error device :",
		     "Screen saver :",
		     NULL
		   },
    * cont_break [] = { " Continue ", " Break ", NULL },
    * ok_        [] = { "  Ok  ", NULL };

#endif

#endif /*_HH*/
