/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: khabout.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/khabout.c,v $
 */

/* khabout */
/* buid a crypted file for the information about the project */

#define GLOBAL

#include <stdlib.h>
#include <fcntl.h>

#include "doabout.hh"		/* source text */
#include "docrypt.h"

#define FILENAME "doabout.h"

int MY_write( int file_h, char * str) {
    return( write( file_h, str, strlen( str)) );
    }

void main( void) {
    int file_h, i, j;
    file_h = open( FILENAME, O_RDWR|O_CREAT|O_TRUNC, 0644 );
    if( file_h < 0) {
	perror( FILENAME);
	exit( 1);
	}
    
    MY_write( file_h, "/* doabout.h */\n\n"
		      "#ifndef DOABOUT_H \n"
		      "#	define DOABOUT_H \n\n"
		      "#ifndef EXTERN\n"
		      "GLOBAL char * cpyright[] = { \n");
    
    for( i=0; about_[i] != NULL; i++) {
	MY_write( file_h, "    \"");
	for( j=0; about_[i][j] != 0; j++) {
	    char c = decrypt( about_[i][j], CRYPT_MODE);
	    MY_write( file_h, &c );
	    }
	MY_write( file_h, "\",\n");
	}
    MY_write( file_h, "    NULL\n"
		      "    };\n\n"
		      "#endif\n\n"
		      "#endif\n");
    close( file_h);
    }
