/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: khfm.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/khfm.c,v $
 */

#	define GLOBAL

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>

#include <time.h>
#include <sys/timeb.h>
#include <malloc.h>
#include <fcntl.h>

#ifdef UNIX

#include <termio.h>
#include <string.h>
#include <sys/types.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#ifdef SCO_UNIX
#include <sys/page.h>
#include <sys/event.h>
#endif

#ifdef SCO_UNIX
#include <tinfo.h>		/* KEY_NUMBER is defined in this file */
#include <sys/console.h>
#include <mouse.h>
#endif

#include <curses.h>

#else			/* ifdef UNIX */

#include <dos.h>
#include <conio.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dolib.h"
#include "dowin.h"
#include "doscr.h"
#include "docfg.h"
#include "doabout.h"
#include "dochoose.h"
#include "docrypt.h"
#include "dodirent.h"
#include "doedit.h"
#include "dofiles.h"
#include "dofind.h"
#include "doframe.h"
#include "dogrep.h"
#include "dohexa.h"
#include "doinit.h"
#include "domem.h"
#include "domenu.h"
#include "domsg.h"
#include "dostat.h"
#include "dostern.h"
#include "dostring.h"
#include "dotcap.h"
#include "dotext.h"
#include "doutil.h"
#include "doqsort.h"
#include "doerror.h"
#include "dostern.h"
#include "dofiles.h"
#include "domem.h"
#include "dogrep.h"
#include "dotext.h"
#include "doabout.h"
#include "docfg.h"
#include "dohist.h"
#include "dofind.h"
#include "docdrom.h"
#include "docopy.h"
#include "dodir.h"

#ifdef EXTERN
#warning EXTERN defined in the main program
#endif

#if defined ( DOS) && defined (MOUSE)
#include "mouse.h"
#endif

/***************************************************************************/
/********************* main program       **********************************/
/***************************************************************************/

void main (int argc, char * argv[])
{
  argc_ = argc;            /* global variables */
  argv_ = argv;

  XDEBUG2(" khdir 1 &cfg=[%p]\n", &MY_cfg);
  XDEBUG2(" khdir 1 sizeof cfg=[%i]\n", sizeof(struct MY_cfg_t));

  strcpy	(prog_path, argv[0]); 	/* voll name of the program */
  init_values	(&MY_cfg);			/* init variables */

  XDEBUG2(" khdir 2 &cfg=[%p]\n", &MY_cfg);
  XDEBUG2(" khdir 3 cfg.max_file_cnt=[%i]\n", MY_cfg.max_file_cnt);
  XDEBUG2(" khdir 4 sizeof cfg=[%i]\n", sizeof(struct MY_cfg_t));

  view_frame	(title_f);
  
  KH_dir (NULL, NULL, NULL, NOMODE) ;

  hide_frame( ins_f, HIDE_MODE|DELETE_MODE);

  quit( 0);
}


