
#ifndef CONFIG_H
#define CONFIG_H

/* at least one of the following two macros will be defined to work */
/* successful HAVE_REALPATH or HAVE_READLINK */
/* when your system supports 'realpath' */
#undef REALPATH

/* your operating system supports 'readlink' */
#define HAVE_READLINK

/* with the Xpm library it's possible to view colored Pixmaps, very nice ! */
#define HAVE_XPM

/* the best, when you have OSF/Motif 2.0 */
#if XmVERSION >= 2
#define HAVE_MOTIF20
#else
#undef HAVE_MOTIF20
#endif

/* have 'lchown', usevoll for symbolic links */
#undef HAVE_LCHOWN

/* have 'regex' and 'regcmp', otherwise 're_comp' */
#undef HAVE_REGEX

/* Many UNIX OS don't have pw_comment (in passwd struct) */
#undef HAVE_PW_COMMENT

/* Editor, used to edit files 'xedit', 'emacs', ..., 'xterm -e vi' */
/* Must be a XWindows Program */
#define TEXT_EDITOR "xterm -e vi"

/* have libgen.h */
#undef HAVE_LIBGEN


#endif
