/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=%M%, SID=%I%, Date=%E% */

/******************************* character functions *************************/

#ifndef USTRUTIL_H
#define USTRUTIL_H

#define TYPE_STRING     0x1000  /* for f_getstr type is string format */
#define TYPE_LOG        0x2000  /* for f_getstr type is logical format */
#define TYPE_INT        0x4000  /* for f_getstr type is logical format */
#define TYPE_HEXA       0x8000

#define TE_NULL		0x0001  /* Terminate a string with \0 */
#define RootDir		'/'	/* Unter UNiX '/' ansonsten '\\' fuer DOS **/

#define StrShellSpecial(c) (c == '\\' || \
			    c == '"' || \
			    c == '\'' || \
			    c == '`' || \
			    c == '$' || \
			    c == '&')
int    StrShellSpecialCnt (char * s);
int    StringBegins     (char *, char *);

#define FIND_CASESENSITIVE	0x0001
int    StringFindNStr (char * str, char * pattern, int len, int mode);
int    StringFindStr  (char * str, char * pattern);
char * StringIndex    (char * s1, char * s2);
char * StrNStrCpy     (char * s1, char * s2, int n);
char * StrReplace     (char * src, char * dest);
char * StrAppend      (char * src, char * toadd);
int    StrIsInt       (char * str);
int    StrChrIndex    (char * str, char chr);

/* convert strings in upper/lower case */
int    is_lowercase ( char   c);
int    is_uppercase ( char   c);

char   ch_lowercase ( char   c);
char   ch_uppercase ( char   c);

void   lowercase    ( char * s);
void   uppercase    ( char * s);

void   strncpy_     ( char * s1, char *s2, int n, int mode);
int    ishexa       ( int ch);
int    isdecimal    ( int ch);
int    is_ascii      ( int ch);
void   setattr      ( int attr);

void   fillstr      ( char * str, int len, char ch);
char * b_strchr     ( char * s, char c);           /* lock for chr. backwords */
int    chrindex     ( char * s1, char * s2);

int    findmatch(char *pat, char *name);

char * dirname ( char * str);
char * basename( char * str);

#endif /*_HH*/
