/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: dodirent.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/dodirent.h,v $
 */

#ifndef DODIRENT_HH
#	define DODIRENT_HH

#include <stdio.h>
#include <fcntl.h>
#include <dirent.h>

#ifdef XENIX
#	define X_opendir 	MY_opendir
#	define X_readdir 	MY_readdir
#	define X_closedir 	MY_closedir
#else
#	define X_opendir 	opendir
#	define X_readdir 	readdir
#	define X_closedir 	closedir
#endif



#ifdef XENIX

DIR *	MY_opendir  ( char * pth);
struct dirent *  MY_readdir  ( DIR * dirp);
void 	MY_closedir ( DIR * dirp);

#endif

#endif /*	define DODIRENT_HH*/
