/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/


/*
 * sem.h 
 */

#ifndef SEM_H
#define SEM_H

#define SEM_CREAT	0x0001
#define SEM_READER	0x0002
#define SEM_WRITER	0x0004

typedef struct
{
  int sid;
  int key;
  int count;
  int info;
} sem_t, * Sem_t;

int semtran   (int key, int semcnt, int mode ) ;
int semcall   (int sid, int op, int snum, int flag) ;
int Up        (int sid, int snum) ;	/* increment semaphore  */
int Down      (int sid, int snum) ;	/* decremtent Semaphore */
int WaitValue (int sid, int snum, int val) ; /* wait for ZERO 	*/
int SetValue  (int sid, int snum, int val) ; /* set semaph to ZERO   */
int GetValue  (int sid, int snum) ;
int delsem    (int sid) ;


#endif /* SEM_H */




