/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: Umessage.h,v 1.1 1996/10/16 07:16:54 khamis Exp $
 * $Source: /home/xkhfm/xkhlib/include/RCS/Umessage.h,v $
 */
/* Funktionsname=message.h, SID=1.4, Date=95/09/19 */

#ifndef MESSAGE_H
#define MESSAGE_H

/********* Diese Drei Flaggen koennen an die Funktion MessageBox als mode *****/
/********* uebergeben werden **************************************************/
/********* Sie bestimmen, welche Buttons bei der MessageBox vorhanden sind ****/
#define OK_BUTTON	0x0001
#define CANCEL_BUTTON	0x0002
#define HELP_BUTTON	0x0004

/********* Falls die Titel und Messagetexte ueber Resourcedateien gesetzt *****/
/********* werden sollen ******************************************************/
#define DONOT_SETMESSAGE	0x0008
#define DONOT_SETTITLE		0x0010
#define NO_TITLE_MESG		(DONOT_SETMESSAGE|DONOT_SETTITLE)

/********* Dialog bei Hilfebutton schliessen **********************************/
#define CLOSE_ON_HELP		0x0020
#define DOPPLE_SIZE		0x0040

#if 0  /* ueber resourcedateien */
/********* Message aligment ***************************************************/
#define MESG_CENTER		0x0080
#define MESG_RIGHT		0x0100
#define MESG_LEFT		0x0200	/* Standard ***************************/
#endif

/********* Fuer 'type' kann man folgende Motif-Werte benutzen *****************/
/********* XmDIALOG_MESSAGE      **********************************************/
/********* XmDIALOG_INFORMATION  **********************************************/
/********* XmDIALOG_ERROR        **********************************************/
/********* XmDIALOG_WARNING      **********************************************/
/********* XmDIALOG_WORKING ***************************************************/
int MessageBox (Widget parent, char * title, char * text,
		int type, 
		int mode,
		void (* ok_prog)     (void),
		void (* cancel_prog) (void));
#define ErrorBox(parent, title, text) MessageBox (parent, \
						  title, \
						  text, \
						  XmDIALOG_ERROR, \
						  OK_BUTTON, \
						  NULL, \
						  NULL)
#endif

