/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: fallback.h,v 1.3 1996/10/28 05:44:09 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/include/RCS/fallback.h,v $
 */
/* Funktionsname=fallback.h, SID=1.3, Date=95/09/19 */

#ifndef FALLBACK_H
#define FALLBACK_H

#include "version.h"

/********* Default-Resourcen (falls nicht in Datei angegeben) ****/
#ifdef IS_EXTERN
EXTERN String * fallbackres;
#else
String	fallbackres[] =
{
#if 0
  /***** Mainwindow Attributes ******/
  "*title:xkhfm",
#endif

  /* diable title for the toolbar for fvwm */
  "Style \"xkhfm@Programs\"  NoTitle, Sticky, WindowListSkip",

  /***** Radiobuttons **/
  "*RadioRights.labelString: Permessions",
  "*RadioRights.titleString: Permessions",
  "*ProperityFlaggs.labelString: Options",

#if 0 /*ndef HAVE_XPM*/
  "*parent.labelType: Pixmap",
  "*parent.labelPixmap: tool_parent_icon",

  "*new.labelType: Pixmap",
  "*new.labelPixmap: tool_new_icon",

  "*open.labelType: Pixmap",
  "*open.labelPixmap: tool_open_icon",

  "*grep.labelType: Pixmap",
  "*grep.labelPixmap: tool_execbg_icon",

  "*find.labelType: Pixmap",
  "*find.labelPixmap: tool_execbg_icon",

  "*exec.labelType: Pixmap",
  "*exec.labelPixmap: tool_execbg_icon",

  "*Xexecute.labelType: Pixmap",
  "*Xexecute.labelPixmap: tool_execbg_icon",

  "*Xexecute.labelType: Pixmap",
  "*Xexecute.labelPixmap: tool_execbg_icon",

  "*execute.labelType: Pixmap",
  "*execute.labelPixmap: tool_execwin_icon",

  "*delete.labelType: Pixmap",
  "*delete.labelPixmap: tool_del_icon",

  "*copy.labelType: Pixmap",
  "*copy.labelPixmap: tool_copy_icon",

  "*mkdir.labelType: Pixmap",
  "*mkdir.labelPixmap: tool_mkdir_icon",

  "*move.labelType: Pixmap",
  "*move.labelPixmap: tool_move_icon",

  "*properities.labelType: Pixmap",
  "*properities.labelPixmap: tool_prop_icon",

  "*link.labelType: Pixmap",
  "*link.labelPixmap: tool_link_icon",

  "*newwindow.labelType: Pixmap",
  "*newwindow.labelPixmap: tool_xkhfm_icon",

  "*vertical.labelType: Pixmap",
  "*vertical.labelPixmap: tool_vert_icon",

  "*horizontal.labelType: Pixmap",
  "*horizontal.labelPixmap: tool_horiz_icon",

  "*fixed.labelType: Pixmap",
  "*fixed.labelPixmap: tool_fix_icon",

  "*large.labelType: Pixmap",
  "*large.labelPixmap: tool_large_icon",

  "*small.labelType: Pixmap",
  "*small.labelPixmap: tool_small_icon",

  "*details.labelType: Pixmap",
  "*details.labelPixmap: tool_details_icon",

  "*add.labelType: Pixmap",
  "*add.labelPixmap: tool_add_icon",
  "*add.labelInsensitivePixmap: tool_addd_icon",
  
  "*mod.labelType: Pixmap",
  "*mod.labelPixmap: tool_mod_icon",
  "*mod.labelInsensitivePixmap: tool_modd_icon",
  
  "*dele.labelType: Pixmap",
  "*dele.labelPixmap: tool_dele_icon",
  "*dele.labelInsensitivePixmap: tool_deled_icon",
  
  "*cpy.labelType: Pixmap",
  "*cpy.labelPixmap: tool_cpy_icon",
  "*cpyd.labelType: Pixmap",
  "*cpyd.labelPixmap: tool_cpyd_icon",
  
  "*paste.labelType: Pixmap",
  "*paste.labelPixmap: tool_paste_icon",
  "*paste.labelInsensitivePixmap: tool_pasted_icon",

  "*undo.labelType: Pixmap",
  "*undo.labelPixmap: tool_undo_icon",
  "*undo.labelInsensitivePixmap: tool_undod_icon",
  
  "*find.labelType: Pixmap",
  "*find.labelPixmap: tool_find_icon",
  "*grep.labelType: Pixmap",
  "*grep.labelPixmap: tool_grep_icon",


  "*Start.labelType: Pixmap",
  "*Start.labelPixmap: tool_run_icon",
  
  "*Close.labelType: Pixmap",
  "*Close.labelPixmap: tool_abort_icon",
  "*Close.labelInsensitivePixmap: tool_abortd_icon",
  
  "*exit.labelType:   Pixmap",
  "*exit.labelPixmap: quit_icon",

  "*Program Starter*Form*Execute.labelType: Pixmap",
  "*Program Starter*Form*Execute.labelPixmap: tool_run_icon",
  "*Program Starter*Form*Close.labelType: Pixmap",
  "*Program Starter*Form*Close.labelPixmap: tool_abort_icon",
  "*Program Starter*Form*Close.labelInsensitivePixmap: tool_abortd_icon",

  "*Properities*Form*Start.labelType: Pixmap",
  "*Properities*Form*Start.labelPixmap: tool_run_icon",
  "*Properities*Form*Close.labelType: Pixmap",
  "*Properities*Form*Close.labelPixmap: tool_abort_icon",
  "*Properities*Form*Close.labelInsensitivePixmap: tool_abortd_icon",

  "*Find*Form*Start.labelType: Pixmap",
  "*Find*Form*Start.labelPixmap: tool_run_icon",
  "*Find*Form*Close.labelType: Pixmap",
  "*Find*Form*Close.labelPixmap: tool_abort_icon",
  "*Find*Form*Close.labelInsensitivePixmap: tool_abortd_icon",

  "*Copy*Form*Start.labelType: Pixmap",
  "*Copy*Form*Start.labelPixmap: tool_run_icon",
  "*Copy*Form*Close.labelType: Pixmap",
  "*Copy*Form*Close.labelPixmap: tool_abort_icon",
  "*Copy*Form*Close.labelInsensitivePixmap: tool_abortd_icon",

  "*Remove*Form*Start.labelType: Pixmap",
  "*Remove*Form*Start.labelPixmap: tool_run_icon",
  "*Remove*Form*Close.labelType: Pixmap",
  "*Remove*Form*Close.labelPixmap: tool_abort_icon",
  "*Remove*Form*Close.labelInsensitivePixmap: tool_abortd_icon",
#endif

  "xkhfm*foreground:black",
  "xkhfm*background:lightgray",

#if 0
  /***** Color managment **/
  "*XmPushButtonGadget*background: gray",
  "*XmPushButtonGadget*foreground: black",
  
  "*XmText*background: white",
  "*XmText*foreground: blue",
  
  "*iconPixmap: leitsys.logo",
  "*traversalOn: true",

  "*highlightColor: red",
  "*highlightThickness: 2",
  "*rowcolone*orientation: vertical",
#endif

  /******  Listenattribute */
#if 0
  "*XmList.selectionPolicy: browse_select",
#endif

  "*XmList.ScrollBarDisplayPolicy: as_needed",

#if 0
  "*XmList*background: gray",
  "*XmList*foreground: black",

  /****** DialogBoxen ******/
  "*XmDialogShell*foreground: black",
  "*XmDialogShell*background: gray",

  /****** MessageBox *******/
  "*.cancelLabelString: cancel",
  "*.helpLabelString: help",
  "*.okLabelString: ok",

  /****** Menu Texte, sprachunabhaengig ************/
  "*menubar*background: SteelBlue2",
  "*menubar*foreground: yellow",
#endif

  /* menu accelerated key hots */
  "xkhfm.xkhfm.menubar*File.New.accelerator: Ctrl<Key>N",
  "xkhfm.xkhfm.menubar*File.New.acceleratorText: Ctrl-N",
  "xkhfm.xkhfm.menubar*File.New Directory.accelerator: <Key>F3",
  "xkhfm.xkhfm.menubar*File.New Directory.acceleratorText: F3",
  "xkhfm.xkhfm.menubar*File.Open.accelerator: Ctrl<Key>O",
  "xkhfm.xkhfm.menubar*File.Open.acceleratorText: Ctrl-O",
  "xkhfm.xkhfm.menubar*File.Find.accelerator: Ctrl<Key>F",
  "xkhfm.xkhfm.menubar*File.Find.acceleratorText: Ctrl-F",
  "xkhfm.xkhfm.menubar*File.Program Starter.accelerator: Ctrl<Key>X",
  "xkhfm.xkhfm.menubar*File.Program Starter.acceleratorText: Ctrl-X",
  "xkhfm.xkhfm.menubar*File.Close.accelerator: Ctrl<Key>E",
  "xkhfm.xkhfm.menubar*File.Close.acceleratorText: Ctrl-E",
  "xkhfm.xkhfm.menubar*File.Quit.accelerator: Ctrl<Key>Q",
  "xkhfm.xkhfm.menubar*File.Quit.acceleratorText: Ctrl-Q",

  "xkhfm.xkhfm.menubar*Edit*Copy.accelerator: Ctrl<Key>C",
  "xkhfm.xkhfm.menubar*Edit*Copy.acceleratorText: Ctrl-C",
  "xkhfm.xkhfm.menubar*Edit*Move.accelerator: <Key>F4",
  "xkhfm.xkhfm.menubar*Edit*Move.acceleratorText: F4",
  "xkhfm.xkhfm.menubar*Edit*Link.accelerator: <Key>F5",
  "xkhfm.xkhfm.menubar*Edit*Link.acceleratorText: F5",
  "xkhfm.xkhfm.menubar*Edit*Delete.accelerator: Ctrl<Key>R",
  "xkhfm.xkhfm.menubar*Edit*Delete.acceleratorText: Ctrl-R",

  "xkhfm.xkhfm.menubar*Edit*Select All.accelerator: Ctrl<Key>A",
  "xkhfm.xkhfm.menubar*Edit*Select All.acceleratorText: Ctrl-A",
  "xkhfm.xkhfm.menubar*Edit*Select Some.accelerator: Ctrl<Key>S",
  "xkhfm.xkhfm.menubar*Edit*Select Some.acceleratorText: Ctrl-S",
  "xkhfm.xkhfm.menubar*Edit*Unselect All.accelerator: Ctrl<Key>U",
  "xkhfm.xkhfm.menubar*Edit*Unselect All.acceleratorText: Ctrl-U",
  "xkhfm.xkhfm.menubar*Edit*Properities.accelerator: Ctrl<Key>P",
  "xkhfm.xkhfm.menubar*Edit*Properities.acceleratorText: Ctrl-P",

#if 0
  "xkhfm*menubar*Edit*Show All Levels.accelerator: <Key>*",
  "xkhfm*menubar*Edit*Show All Levels.acceleratorText: *",
#endif

  "xkhfm.xkhfm.menubar*View*Large Icons.accelerator: <Key>F6",
  "xkhfm.xkhfm.menubar*View*Large Icons.acceleratorText: F6",
  "xkhfm.xkhfm.menubar*View*Smale Icons.accelerator: <Key>F7",
  "xkhfm.xkhfm.menubar*View*Smale Icons.acceleratorText: F7",
  "xkhfm.xkhfm.menubar*View*Details.accelerator: <Key>F8",
  "xkhfm.xkhfm.menubar*View*Details.acceleratorText: F8",
  "xkhfm.xkhfm.menubar*View*Filter.accelerator: <Key>F9",
  "xkhfm.xkhfm.menubar*View*Filter.acceleratorText: F9",

#if 0
  "xkhfm*menubar*Refresh.accelerator: Ctrl<Key>R",
  "xkhfm*menubar*Refresh.acceleratorText: Ctrl-R",
#endif

  "xkhfm.xkhfm.menubar*History*Home.accelerator: <Key>F2",
  "xkhfm.xkhfm.menubar*History*Home.acceleratorText: F2",
  
  /* Find util */
  "xkhfm.Find.menubar*Start.accelerator: <Key>Return",
  "xkhfm.Find.menubar*Start.acceleratorText: Return",
  "xkhfm.Find.menubar*Delete Selected.accelerator: Ctrl<Key>R",
  "xkhfm.Find.menubar*Delete Selected.acceleratorText: Ctrl-R",
  "xkhfm.Find.menubar*GoTo.labelString: Go to first selected item",
  "xkhfm.Find.menubar*GoTo.accelerator: <Key>F5",
  "xkhfm.Find.menubar*GoTo.acceleratorText: F5",
  "xkhfm.Find.menubar*Select All.accelerator: Ctrl<Key>A",
  "xkhfm.Find.menubar*Select All.acceleratorText: Ctrl-A",
  "xkhfm.Find.menubar*Unselect All.accelerator: Ctrl<Key>U",
  "xkhfm.Find.menubar*Unselect All.acceleratorText: Ctrl-U",

  "xkhfm.Find.menubar*Close.accelerator: <Key>Escape",
  "xkhfm.Find.menubar*Close.acceleratorText: Esc",

  "xkhfm.Program Starter.menubar*Run.accelerator: <Key>Return",
  "xkhfm.Program Starter.menubar*Run.acceleratorText: Return",
  "xkhfm.Program Starter.menubar*Close.accelerator: <Key>Escape",
  "xkhfm.Program Starter.menubar*Close.acceleratorText: Esc",

  "*Copy - Move.menubar*Copy.accelerator: <Key>Return",
  "*Copy - Move.menubar*Copy.acceleratorText: Return",
  "*Copy - Move.menubar*Close.accelerator: <Key>Escape",
  "*Copy - Move.menubar*Close.acceleratorText: Esc",

  "*Properities.menubar*Start.accelerator: <Key>Return",
  "*Properities.menubar*Start.acceleratorText: Return",
  "*Properities.menubar*Close.accelerator: <Key>Escape",
  "*Properities.menubar*Close.acceleratorText: Esc",

#if 0
  /****** ApplicationBox (AppList_t) -Buttons ******/
  "*Add.labelString:	add",
  "*Entf.labelString:	del",
  "*Mod.labelString:	mod",
  "*Undo.labelString:	undo",
  "*Copy.labelString:	copy", /* duplicate with menubar*copy */
  "*Paste.labelString:	paste",
#endif
  
  /****** DialogBoxlabels: OkLabel = "OK",		*/
  /******		   CancelLabel = "Cancel",	*/
  /******		   HelpLabel = "Help"		*/
  /****** About Maske ***/
  "*About*OK*labelType:   Pixmap",
  "*About*OK*labelPixmap: About_OK_icon",
  /*"*About*helpLabelString:   Khamis drives his Donkey",*/

  "*About.dialogTitle:		xkhfm",
  "*About*messageAlignment:     alignment_center",
  "*About.messageString:	" PROGRAM_ABOUT,

  /****** About Maske *****/
  "*RemoveAsk*messageAlignment:  alignment_center",
  "*RemoveAsk*okLabelString:     Remove",
  "*RemoveAsk*cancelLabelString: Continue",
  "*RemoveAsk*helpLabelString:   Cancel",
  "*RemoveAsk.dialogTitle:	 Remove",

  "*RemoveError*messageAlignment:  alignment_center",
  "*RemoveError*okLabelString:     Continue",
  "*RemoveError*cancelLabelString: Cancel",
  "*RemoveError.dialogTitle:	   Remove Error",

  "*RemoveBreak*okLabelString:     Continue",
  "*RemoveBreak*cancelLabelString: Cancel",
  "*RemoveBreak*messageAlignment:  alignment_center",
  "*RemoveBreak.messageString:     Break removing process, are you sure ?",
  "*RemoveBreak.dialogTitle:       Removing Process",

  "*CopyAsk*okLabelString:     Copy",
  "*CopyAsk*messageAlignment:  alignment_center",
  "*CopyAsk*cancelLabelString: Continue",
  "*CopyAsk*helpLabelString:   Cancel",
  "*CopyAsk.dialogTitle:       Copy",

  "*OverwriteAsk*messageAlignment:  alignment_center",
  "*OverwriteAsk*okLabelString:     Overwrite",
  "*OverwriteAsk*cancelLabelString: All",
  "*OverwriteAsk*helpLabelString:   Cancel",
  "*OverwriteAsk.dialogTitle:       Overwrite existing file",

  "*CopyError*messageAlignment:  alignment_center",
  "*CopyError*okLabelString:     Continue",
  "*CopyError*cancelLabelString: Cancel",
  "*CopyError.dialogTitle:	 Copy Error",

  "*CopyBreak*okLabelString:     Continue",
  "*CopyBreak*cancelLabelString: Cancel",
  "*CopyBreak*messageAlignment:  alignment_center",
  "*CopyBreak.messageString:     Break copying process, are you sure ?",
  "*CopyBreak.dialogTitle:       Copy Process",

  "*PropError*messageAlignment:  alignment_center",
  "*PropError*okLabelString:     Continue",
  "*PropError*cancelLabelString: Cancel",
  "*PropError.dialogTitle:	 Properities Error",

  "*PropAsk*okLabelString:     Properities",
  "*PropAsk*messageAlignment:  alignment_center",
  "*PropAsk*cancelLabelString: Continue",
  "*PropAsk*helpLabelString:   Cancel",
  "*PropAsk.dialogTitle:       Change",

  "*MkDirError*okLabelString:     Ok",
  "*MkDirError*messageAlignment:  alignment_center",
  "*MkDirError.messageString:     Error by creating a new directory",
  "*MkDirError.dialogTitle:       Error",

  "*mkdir.dialogTitle:	Create a new directory",
  "*mkdir.selectionLabelString:	the name of the new directory",

  "*FilterDialog.dialogTitle:	Filter",
  "*FilterDialog.selectionLabelString:	Please enter the new pattern",

  "*SelectDialog.dialogTitle:	Select some entries",
  "*SelectDialog.selectionLabelString:	Please enter the selection pattern",

  "*FindError*messageAlignment:  alignment_center",
  "*FindError*okLabelString:     Continue",
  "*FindError*cancelLabelString: Cancel",
  "*FindError.dialogTitle:	 Error",

  "*FindBreakDialog*messageAlignment:  alignment_center",
  "*FindBreakDialog.messageString:     Abort searching, are you sure ?",
  "*FindBreakDialog*okLabelString:     Continue",
  "*FindBreakDialog*cancelLabelString: Cancel",
  "*FindBreakDialog.dialogTitle:       Find",

  NULL
};
#endif  /* IS_EXTERN */

#endif
