/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinCrPixmaps.c,v 1.3 1996/10/28 05:44:46 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/mwinCrPixmaps.c,v $
 */

#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <Xm/DrawingA.h>
#include "Xinc.h"

#include "defines.h"

#ifdef HAVE_XPM
#include <X11/xpm.h>
#endif

#include "mainwin.h"

/* include pixmaps for the different file types */
#ifdef HAVE_XPM
#include "pixmap/file16.pixm"
#include "pixmap/file32.pixm"
#include "pixmap/file_archive32.pixm"
#include "pixmap/file_assembler32.pixm"
#include "pixmap/file_bmp32.pixm"
#include "pixmap/file_cheader32.pixm"
#include "pixmap/file_clock32.pixm"
#include "pixmap/file_compr32.pixm"
#include "pixmap/file_core32.pixm"
#include "pixmap/file_csource32.pixm"
#include "pixmap/file_devblk16.pixm"
#include "pixmap/file_devblk32.pixm"
#include "pixmap/file_devchr16.pixm"
#include "pixmap/file_devchr32.pixm"
#include "pixmap/file_disk35zoll32.pixm"
#include "pixmap/file_disk525zoll32.pixm"
#include "pixmap/file_Disk_A32.pixm"
#include "pixmap/file_doc1_32.pixm"
#include "pixmap/file_doc2_32.pixm"
#include "pixmap/file_doc3_32.pixm"
#include "pixmap/file_dos32.pixm"
#include "pixmap/file_dosBAT32.pixm"
#include "pixmap/file_dosCOM32.pixm"
#include "pixmap/file_dosEXE32.pixm"
#include "pixmap/file_exec16.pixm"
#include "pixmap/file_exec32.pixm"
#include "pixmap/file_fax32.pixm"
#include "pixmap/file_font32.pixm"
#include "pixmap/file_gif32.pixm"
#include "pixmap/file_group32.pixm"
#include "pixmap/file_iff32.pixm"
#include "pixmap/file_image32.pixm"
#include "pixmap/file_info32.pixm"
#include "pixmap/file_iris32.pixm"
#include "pixmap/file_jpeg32.pixm"
#include "pixmap/file_link16.pixm"
#include "pixmap/file_link32.pixm"
#include "pixmap/file_mail32.pixm"
#include "pixmap/file_makefile32.pixm"
#include "pixmap/file_mouse32.pixm"
#include "pixmap/file_obj32.pixm"
#include "pixmap/file_package32.pixm"
#include "pixmap/file_pbm32.pixm"
#include "pixmap/file_pcx32.pixm"
#include "pixmap/file_pipe16.pixm"
#include "pixmap/file_pipe32.pixm"
#include "pixmap/file_pm32.pixm"
#include "pixmap/file_ps32.pixm"
#include "pixmap/file_ress32.pixm"
#include "pixmap/file_rle32.pixm"
#include "pixmap/file_sched32.pixm"
#include "pixmap/file_sem16.pixm"
#include "pixmap/file_sem32.pixm"
#include "pixmap/file_sharedobj32.pixm"
#include "pixmap/file_shmem16.pixm"
#include "pixmap/file_shmem32.pixm"
#include "pixmap/file_sound32.pixm"
#include "pixmap/file_tape32.pixm"
#include "pixmap/file_term32.pixm"
#include "pixmap/file_tiff32.pixm"
#include "pixmap/file_unknown16.pixm"
#include "pixmap/file_unknown32.pixm"
#include "pixmap/file_win32.pixm"
#include "pixmap/file_xbm32.pixm"
#include "pixmap/file_xpm32.pixm"
#include "pixmap/file_xwd32.pixm"

#include "pixmap/fldr16.pixm"
#include "pixmap/fldr32.pixm"
#include "pixmap/fldr_admin32.pixm"
#include "pixmap/fldr_appl32.pixm"
#include "pixmap/fldr_cdrom32.pixm"
#include "pixmap/fldr_dev32.pixm"
#include "pixmap/fldr_email32.pixm"
#include "pixmap/fldr_font32.pixm"
#include "pixmap/fldr_games32.pixm"
#include "pixmap/fldr_map32.pixm"
#include "pixmap/fldr_nfs32.pixm"
#include "pixmap/fldr_nfsLocal32.pixm"
#include "pixmap/fldr_nfsMounted32.pixm"
#include "pixmap/fldr_open32.pixm"
#include "pixmap/fldr_proc_off32.pixm"
#include "pixmap/fldr_proc_on32.pixm"
#include "pixmap/fldr_start32.pixm"
#include "pixmap/fldr_uucp32.pixm"
#include "pixmap/fldr_wb32.pixm"

#include "pixmap/host16.pixm"
#include "pixmap/keybd32.pixm"
#include "pixmap/kh_on_donkey.pixm"
#include "pixmap/ptool.pixm"
#include "pixmap/quit24.pixm"
#include "pixmap/quit32.pixm"

#include "pixmap/tool_copy24.pixm"
#include "pixmap/tool_del24.pixm"
#include "pixmap/tool_details24.pixm"
#include "pixmap/tool_draw24.pixm"
#include "pixmap/tool_edit24.pixm"
#include "pixmap/tool_execbg24.pixm"
#include "pixmap/tool_execwin24.pixm"
#include "pixmap/tool_fix24.pixm"
#include "pixmap/tool_horiz24.pixm"
#include "pixmap/tool_large24.pixm"
#include "pixmap/tool_link24.pixm"
#include "pixmap/tool_mkdir24.pixm"
#include "pixmap/tool_move24.pixm"
#include "pixmap/tool_new24.pixm"
#include "pixmap/tool_open24.pixm"
#include "pixmap/tool_parent24.pixm"
#include "pixmap/tool_print24.pixm"
#include "pixmap/tool_prop24.pixm"
#include "pixmap/tool_save24.pixm"
#include "pixmap/tool_saveas24.pixm"
#include "pixmap/tool_small24.pixm"
#include "pixmap/tool_sortdf24.pixm"
#include "pixmap/tool_sortn24.pixm"
#include "pixmap/tool_vert24.pixm"
#include "pixmap/tool_abort48.pixm"
#include "pixmap/tool_abortd48.pixm"
#include "pixmap/tool_stop48.pixm"
#include "pixmap/tool_run48.pixm"
#include "pixmap/tool_xkhfm24.pixm"

#include "pixmap/tool_add24.pixm"
#include "pixmap/tool_addd24.pixm"
#include "pixmap/tool_mod24.pixm"
#include "pixmap/tool_modd24.pixm"
#include "pixmap/tool_dele24.pixm"
#include "pixmap/tool_deled24.pixm"
#include "pixmap/tool_cpy24.pixm"
#include "pixmap/tool_cpyd24.pixm"
#include "pixmap/tool_paste24.pixm"
#include "pixmap/tool_pasted24.pixm"
#include "pixmap/tool_undo24.pixm"
#include "pixmap/tool_undod24.pixm"
#include "pixmap/tool_find24.pixm"
#include "pixmap/tool_grep24.pixm"

#include "pixmap/tree_dir16.pixm"
#include "pixmap/tree_odir16.pixm"
#include "pixmap/win32.pixm"
#else
#include "bitmap/file16.icon"
#include "bitmap/file32.icon"
#include "bitmap/file_archive32.icon"
#include "bitmap/file_assembler32.icon"
#include "bitmap/file_bmp32.icon"
#include "bitmap/file_cheader32.icon"
#include "bitmap/file_clock32.icon"
#include "bitmap/file_compr32.icon"
#include "bitmap/file_core32.icon"
#include "bitmap/file_csource32.icon"
#include "bitmap/file_devblk16.icon"
#include "bitmap/file_devblk32.icon"
#include "bitmap/file_devchr16.icon"
#include "bitmap/file_devchr32.icon"
#include "bitmap/file_disk35zoll32.icon"
#include "bitmap/file_disk525zoll32.icon"
#include "bitmap/file_Disk_A32.icon"
#include "bitmap/file_doc1_32.icon"
#include "bitmap/file_doc2_32.icon"
#include "bitmap/file_doc3_32.icon"
#include "bitmap/file_dos32.icon"
#include "bitmap/file_dosBAT32.icon"
#include "bitmap/file_dosCOM32.icon"
#include "bitmap/file_dosEXE32.icon"
#include "bitmap/file_exec16.icon"
#include "bitmap/file_exec32.icon"
#include "bitmap/file_fax32.icon"
#include "bitmap/file_font32.icon"
#include "bitmap/file_gif32.icon"
#include "bitmap/file_group32.icon"
#include "bitmap/file_iff32.icon"
#include "bitmap/file_image32.icon"
#include "bitmap/file_info32.icon"
#include "bitmap/file_iris32.icon"
#include "bitmap/file_jpeg32.icon"
#include "bitmap/file_link16.icon"
#include "bitmap/file_link32.icon"
#include "bitmap/file_mail32.icon"
#include "bitmap/file_makefile32.icon"
#include "bitmap/file_mouse32.icon"
#include "bitmap/file_obj32.icon"
#include "bitmap/file_package32.icon"
#include "bitmap/file_pbm32.icon"
#include "bitmap/file_pcx32.icon"
#include "bitmap/file_pipe16.icon"
#include "bitmap/file_pipe32.icon"
#include "bitmap/file_pm32.icon"
#include "bitmap/file_ps32.icon"
#include "bitmap/file_ress32.icon"
#include "bitmap/file_rle32.icon"
#include "bitmap/file_sched32.icon"
#include "bitmap/file_sem16.icon"
#include "bitmap/file_sem32.icon"
#include "bitmap/file_sharedobj32.icon"
#include "bitmap/file_shmem16.icon"
#include "bitmap/file_shmem32.icon"
#include "bitmap/file_sound32.icon"
#include "bitmap/file_tape32.icon"
#include "bitmap/file_term32.icon"
#include "bitmap/file_tiff32.icon"
#include "bitmap/file_unknown16.icon"
#include "bitmap/file_unknown32.icon"
#include "bitmap/file_xbm32.icon"
#include "bitmap/file_xpm32.icon"
#include "bitmap/file_win32.icon"
#include "bitmap/file_xwd32.icon"
#include "bitmap/fldr16.icon"
#include "bitmap/fldr32.icon"
#include "bitmap/fldr_admin32.icon"
#include "bitmap/fldr_appl32.icon"
#include "bitmap/fldr_cdrom32.icon"
#include "bitmap/fldr_dev32.icon"
#include "bitmap/fldr_email32.icon"
#include "bitmap/fldr_font32.icon"
#include "bitmap/fldr_games32.icon"
#include "bitmap/fldr_map32.icon"
#include "bitmap/fldr_nfs32.icon"
#include "bitmap/fldr_nfsLocal32.icon"
#include "bitmap/fldr_nfsMounted32.icon"
#include "bitmap/fldr_open32.icon"
#include "bitmap/fldr_proc_off32.icon"
#include "bitmap/fldr_proc_on32.icon"
#include "bitmap/fldr_start32.icon"
#include "bitmap/fldr_uucp32.icon"
#include "bitmap/fldr_wb32.icon"

#include "bitmap/host16.icon"
#include "bitmap/keybd32.icon"
#include "bitmap/kh_on_donkey.icon"
#include "bitmap/ptool.icon"
#include "bitmap/quit24.icon"
#include "bitmap/quit32.icon"

#include "bitmap/tool_copy24.icon"
#include "bitmap/tool_del24.icon"
#include "bitmap/tool_details24.icon"
#include "bitmap/tool_draw24.icon"
#include "bitmap/tool_edit24.icon"
#include "bitmap/tool_execbg24.icon"
#include "bitmap/tool_execwin24.icon"
#include "bitmap/tool_fix24.icon"
#include "bitmap/tool_horiz24.icon"
#include "bitmap/tool_large24.icon"
#include "bitmap/tool_link24.icon"
#include "bitmap/tool_mkdir24.icon"
#include "bitmap/tool_move24.icon"
#include "bitmap/tool_new24.icon"
#include "bitmap/tool_open24.icon"
#include "bitmap/tool_parent24.icon"
#include "bitmap/tool_print24.icon"
#include "bitmap/tool_prop24.icon"
#include "bitmap/tool_save24.icon"
#include "bitmap/tool_saveas24.icon"
#include "bitmap/tool_small24.icon"
#include "bitmap/tool_sortdf24.icon"
#include "bitmap/tool_sortn24.icon"
#include "bitmap/tool_vert24.icon"
#include "bitmap/tool_abort48.icon"
#include "bitmap/tool_abortd48.icon"
#include "bitmap/tool_stop48.icon"
#include "bitmap/tool_run48.icon"
#include "bitmap/tool_xkhfm24.icon"

#include "bitmap/tool_add24.icon"
#include "bitmap/tool_addd24.icon"
#include "bitmap/tool_mod24.icon"
#include "bitmap/tool_modd24.icon"
#include "bitmap/tool_dele24.icon"
#include "bitmap/tool_deled24.icon"
#include "bitmap/tool_cpy24.icon"
#include "bitmap/tool_cpyd24.icon"
#include "bitmap/tool_paste24.icon"
#include "bitmap/tool_pasted24.icon"
#include "bitmap/tool_undo24.icon"
#include "bitmap/tool_undod24.icon"
#include "bitmap/tool_find24.icon"
#include "bitmap/tool_grep24.icon"

#include "bitmap/tree_dir16.icon"
#include "bitmap/tree_odir16.icon"
#include "bitmap/win32.icon"
#endif

#define BYTES_PER_LINE(width) ((width/8) + (width%8 ? 1 : 0))

#ifdef HAVE_XPM
#define INSTALL_IMAGE(imgName, prefix, iconName) \
{ \
XImage * shapemask; \
int ret; \
DEBUG2("mwinCrPixmap: create pixmap=(%i)\n", PIXM_##prefix); \
ret = XpmCreateImageFromData(display, \
			     prefix##_pixm, \
			     &imgName, \
			     NULL /*&shapemask*/ , \
			     NULL); \
if (ret == XpmColorFailed) \
{ \
    XpmAttributes attributes; \
    attributes.colormap = XCreateColormap(display, \
    			       rootWindow, \
			       DefaultVisual(display, DefaultScreen(display)), \
			       AllocNone); \
    attributes.valuemask |= XpmColormap; \
    ret = XpmCreateImageFromData(display, \
			     prefix##_pixm, \
			     &imgName, \
			     NULL /*&shapemask*/, \
			     &attributes); \
  } \
if (ret != XpmSuccess) \
{ \
    ERROR3 ("mwinCrPixmaps: %s %s\n", imgName, XpmGetErrorString(ret)); \
    exit(1); \
} \
DEBUG1 ("image created"); \
XmInstallImage (imgName, iconName); \
}
#else
#define INSTALL_IMAGE(imgName, prefix, iconName) \
{ \
imgName.width	= prefix##_width; \
imgName.height = prefix##_height; \
imgName.data   = (char*) prefix##_bits; \
imgName.xoffset = 0; \
imgName.format = XYBitmap; \
imgName.byte_order = MSBFirst; \
imgName.bitmap_pad = 8; \
imgName.bitmap_bit_order = LSBFirst; \
imgName.bitmap_unit = 8; \
imgName.depth = 1; \
imgName.bytes_per_line = BYTES_PER_LINE (prefix##_width); \
imgName.obdata = NULL; \
XmInstallImage (&imgName,  iconName); \
}
#endif

#if 0
#define INSTALL_PIXMAP(prefix) \
{ \
  int ret; \
  DEBUG2("mwinCrPixmap: create pixmap=(%i)\n", PIXM_##prefix); \
  ret = XpmCreatePixmapFromData(display, \
				rootWindow, \
				prefix##_pixm, \
				&pxmList[PIXM_##prefix], \
				NULL, NULL); \
  if (ret != XpmSuccess) \
    { \
      ERROR2 ("mwinCrPixmaps: %s\n", XpmGetErrorString(ret)); \
      exit(1); \
    } \
}
#endif

#define INSTALL_PIXMAP(prefix) \
{ \
pxmList[PIXM_##prefix]  = XCreatePixmapFromBitmapData (display, \
						      rootWindow, \
						      prefix##_bits, \
						      prefix##_width, \
						      prefix##_height, \
						      fg, bg, 1); \
if (pxmList[PIXM_##prefix] <= NULL) \
{ \
    ERROR2("mwinCrPixmaps: can not create Pixmap number %i\n", PIXM_##prefix); \
} \
pxmWidth [PIXM_##prefix] = prefix##_width; \
pxmHeight[PIXM_##prefix] = prefix##_height; \
}

Pixmap mwinConvertPixmap (int format,
			  int width,
			  int height,
			  int ncolors,
			  int chars_per_pixel,
			  char * m_colors[],
			  char * m_pixels[]);

int mwinCrPixmaps (void)
{
#ifdef HAVE_XPM
  XpmAttributes attributes;
  Colormap colormap;
  XColor color, junk;
#endif
  Pixel fg = 1 /*WhitePixel (display, theScreen)*/ ;
  Pixel bg = 0 /*BlackPixel (display, theScreen)*/ ;
  int i, x, y;

  DEBUG1 ("mwinCrPixmaps: Create pixmaps");

#if 0
  memset (&attributes, 0, sizeof (XpmAttributes));
  /* initialize the colormap */
  colormap = XDefaultColormapOfScreen (XtScreen (rootWindow));
  colormap = XCreateColormap(display, rootWindow,
			     DefaultVisual(display, DefaultScreen(display)),
			     AllocNone);
  attributes.colormap = colormap;

  if (XAllocNamedColor (display, colormap, "black", &color, &junk))
    bg = color.pixel;
  else
    bg = XBlackPixelOfScreen (XtScreen (rootWindow));
#endif

#ifdef HAVE_XPM
  PixmIconWidth		   = 32;
  PixmIconHeight	   = 32;
#else
  PixmIconWidth		   = file32_width;
  PixmIconHeight	   = file32_height;
#endif

  DEBUG1 ("Install Images");

  i = 0;
#if 0 /*ndef HAVE_XPM*/
  /* pixmaps for buttons */
  INSTALL_IMAGE (imgList[i], tool_parent24, "tool_parent_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_execbg24, "tool_execbg_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_execwin24,"tool_execwin_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_new24,    "tool_new_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_open24,   "tool_open_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_del24,    "tool_del_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_copy24,   "tool_copy_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_link24,   "tool_link_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_mkdir24,  "tool_mkdir_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_move24,   "tool_move_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_prop24,   "tool_prop_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_edit24,   "tool_edit_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_xkhfm24,  "tool_xkhfm_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_vert24,   "tool_vert_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_abort48,  "tool_abort_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_abortd48, "tool_abortd_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_stop48,   "tool_stop_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_run48,    "tool_run_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_fix24,    "tool_fix_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_horiz24,  "tool_horiz_icon"); i++;

  INSTALL_IMAGE (imgList[i], tool_large24,  "tool_large_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_small24,  "tool_small_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_details24,"tool_details_icon"); i++;

  INSTALL_IMAGE (imgList[i], tool_add24,    "tool_add_icon");    i++;
  INSTALL_IMAGE (imgList[i], tool_addd24,   "tool_addd_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_mod24,    "tool_mod_icon");    i++;
  INSTALL_IMAGE (imgList[i], tool_modd24,   "tool_modd_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_dele24,   "tool_dele_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_deled24,  "tool_deled_icon");  i++;
  INSTALL_IMAGE (imgList[i], tool_cpy24,    "tool_cpy_icon");    i++;
  INSTALL_IMAGE (imgList[i], tool_cpyd24,   "tool_cpyd_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_paste24,  "tool_paste_icon");  i++;
  INSTALL_IMAGE (imgList[i], tool_pasted24, "tool_pasted_icon"); i++;
  INSTALL_IMAGE (imgList[i], tool_undo24,   "tool_undo_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_undod24,  "tool_undod_icon");  i++;
  INSTALL_IMAGE (imgList[i], tool_find24,   "tool_find_icon");   i++;
  INSTALL_IMAGE (imgList[i], tool_grep24,   "tool_grep_icon");   i++;

  INSTALL_IMAGE (imgList[i], quit24,        "quit_icon"); i++;
#endif

  INSTALL_IMAGE (imgList[i], kh_on_donkey,  "About_OK_icon"); i++;

#ifndef HAVE_XPM
  /* file types */
  INSTALL_PIXMAP (file16);
  INSTALL_PIXMAP (file32);
  INSTALL_PIXMAP (file_archive32);
  INSTALL_PIXMAP (file_assembler32);
  INSTALL_PIXMAP (file_bmp32);
  INSTALL_PIXMAP (file_cheader32);
  INSTALL_PIXMAP (file_clock32);
  INSTALL_PIXMAP (file_compr32);
  INSTALL_PIXMAP (file_core32);
  INSTALL_PIXMAP (file_csource32);
  INSTALL_PIXMAP (file_devblk16);
  INSTALL_PIXMAP (file_devblk32);
  INSTALL_PIXMAP (file_devchr16);
  INSTALL_PIXMAP (file_devchr32);
  INSTALL_PIXMAP (file_disk35zoll32);
  INSTALL_PIXMAP (file_disk525zoll32);
  INSTALL_PIXMAP (file_Disk_A32);
  INSTALL_PIXMAP (file_doc1_32);
  INSTALL_PIXMAP (file_doc2_32);
  INSTALL_PIXMAP (file_doc3_32);
  INSTALL_PIXMAP (file_dos32);
  INSTALL_PIXMAP (file_dosBAT32);
  INSTALL_PIXMAP (file_dosCOM32);
  INSTALL_PIXMAP (file_dosEXE32);
  INSTALL_PIXMAP (file_exec16);
  INSTALL_PIXMAP (file_exec32);
  INSTALL_PIXMAP (file_fax32);
  INSTALL_PIXMAP (file_font32);
  INSTALL_PIXMAP (file_gif32);
  INSTALL_PIXMAP (file_group32);
  INSTALL_PIXMAP (file_iff32);
  INSTALL_PIXMAP (file_image32);
  INSTALL_PIXMAP (file_info32);
  INSTALL_PIXMAP (file_iris32);
  INSTALL_PIXMAP (file_jpeg32);
  INSTALL_PIXMAP (file_link16);
  INSTALL_PIXMAP (file_link32);
  INSTALL_PIXMAP (file_mail32);
  INSTALL_PIXMAP (file_makefile32);
  INSTALL_PIXMAP (file_mouse32);
  INSTALL_PIXMAP (file_obj32);
  INSTALL_PIXMAP (file_package32);
  INSTALL_PIXMAP (file_pbm32);
  INSTALL_PIXMAP (file_pcx32);
  INSTALL_PIXMAP (file_pipe16);
  INSTALL_PIXMAP (file_pipe32);
  INSTALL_PIXMAP (file_pm32);
  INSTALL_PIXMAP (file_ps32);
  INSTALL_PIXMAP (file_ress32);
  INSTALL_PIXMAP (file_rle32);
  INSTALL_PIXMAP (file_sched32);
  INSTALL_PIXMAP (file_sem16);
  INSTALL_PIXMAP (file_sem32);
  INSTALL_PIXMAP (file_sharedobj32);
  INSTALL_PIXMAP (file_shmem16);
  INSTALL_PIXMAP (file_shmem32);
  INSTALL_PIXMAP (file_sound32);
  INSTALL_PIXMAP (file_tape32);
  INSTALL_PIXMAP (file_term32);
  INSTALL_PIXMAP (file_tiff32);
  INSTALL_PIXMAP (file_unknown16);
  INSTALL_PIXMAP (file_unknown32);
  INSTALL_PIXMAP (file_win32);
  INSTALL_PIXMAP (file_xbm32);
  INSTALL_PIXMAP (file_xpm32);
  INSTALL_PIXMAP (file_xwd32);
  INSTALL_PIXMAP (fldr16);
  INSTALL_PIXMAP (fldr32);
  INSTALL_PIXMAP (fldr_admin32);
  INSTALL_PIXMAP (fldr_appl32);
  INSTALL_PIXMAP (fldr_cdrom32);
  INSTALL_PIXMAP (fldr_dev32);
  INSTALL_PIXMAP (fldr_email32);
  INSTALL_PIXMAP (fldr_font32);
  INSTALL_PIXMAP (fldr_games32);
  INSTALL_PIXMAP (fldr_map32);
  INSTALL_PIXMAP (fldr_nfs32);
  INSTALL_PIXMAP (fldr_nfsLocal32);
  INSTALL_PIXMAP (fldr_nfsMounted32);
  INSTALL_PIXMAP (fldr_open32);
  INSTALL_PIXMAP (fldr_proc_off32);
  INSTALL_PIXMAP (fldr_proc_on32);
  INSTALL_PIXMAP (fldr_start32);
  INSTALL_PIXMAP (fldr_uucp32);
  INSTALL_PIXMAP (fldr_wb32);
  INSTALL_PIXMAP (host16);
  INSTALL_PIXMAP (keybd32);
  INSTALL_PIXMAP (kh_on_donkey);
  INSTALL_PIXMAP (ptool);
  INSTALL_PIXMAP (quit24);
  INSTALL_PIXMAP (quit32);
  INSTALL_PIXMAP (tool_copy24);
  INSTALL_PIXMAP (tool_del24);
  INSTALL_PIXMAP (tool_details24);
  INSTALL_PIXMAP (tool_draw24);
  INSTALL_PIXMAP (tool_edit24);
  INSTALL_PIXMAP (tool_execbg24);
  INSTALL_PIXMAP (tool_execwin24);
  INSTALL_PIXMAP (tool_fix24);
  INSTALL_PIXMAP (tool_horiz24);
  INSTALL_PIXMAP (tool_large24);
  INSTALL_PIXMAP (tool_link24);
  INSTALL_PIXMAP (tool_mkdir24);
  INSTALL_PIXMAP (tool_move24);
  INSTALL_PIXMAP (tool_new24);
  INSTALL_PIXMAP (tool_open24);
  INSTALL_PIXMAP (tool_parent24);
  INSTALL_PIXMAP (tool_prop24);
  INSTALL_PIXMAP (tool_print24);
  INSTALL_PIXMAP (tool_save24);
  INSTALL_PIXMAP (tool_saveas24);
  INSTALL_PIXMAP (tool_small24);
  INSTALL_PIXMAP (tool_sortdf24);
  INSTALL_PIXMAP (tool_sortn24);
  INSTALL_PIXMAP (tool_vert24);
  INSTALL_PIXMAP (tool_abort48);
  INSTALL_PIXMAP (tool_abortd48);
  INSTALL_PIXMAP (tool_stop48);
  INSTALL_PIXMAP (tool_run48);
  INSTALL_PIXMAP (tool_xkhfm24);

  INSTALL_PIXMAP (tool_add24);
  INSTALL_PIXMAP (tool_addd24);
  INSTALL_PIXMAP (tool_mod24);
  INSTALL_PIXMAP (tool_modd24);
  INSTALL_PIXMAP (tool_dele24);
  INSTALL_PIXMAP (tool_deled24);
  INSTALL_PIXMAP (tool_cpy24);
  INSTALL_PIXMAP (tool_cpyd24);
  INSTALL_PIXMAP (tool_paste24);
  INSTALL_PIXMAP (tool_pasted24);
  INSTALL_PIXMAP (tool_undo24);
  INSTALL_PIXMAP (tool_undod24);
  INSTALL_PIXMAP (tool_find24);
  INSTALL_PIXMAP (tool_grep24);

  INSTALL_PIXMAP (tree_dir16);
  INSTALL_PIXMAP (tree_odir16);
  INSTALL_PIXMAP (win32);
#endif

  DEBUG2 ("mwinCrPixmaps: pxmList[DIR]=(%li)\n",
	  pxmList[TYPE_DIR]);
  

  DEBUG1 ("mwinCrPixmap: Pixmaps created");

  return True;
}

#if 0
#define DEPTH	1
Pixmap mwinConvertPixmap (int format,
			  int width,
			  int height,
			  int ncolors,
			  int chars_per_pixel,
			  char * colors[],
			  char * pixels[])
{
  Pixel fg = 1, bg = 0;
  Pixmap pixm;
  int i, j, l, k;

  DEBUG1 ("mwinConvertPixmap:");

  if (chars_per_pixel != 1)
    return 0;

  pixm = XCreatePixmap (display,
			rootWindow,
			width,
			height,
			8*DEPTH);
  
  for (i=0; i<height; i++)
    for (j=0; j<width; j++)
      {
	for (l=0; l<ncolors; l++)
	  if (pixels[i][j] == colors[l*2][0])
	    {
	      break;
	    }
	XSetForeground (display, theGC,
			/*l<ncolors ? colors[l][1]:*/
			(i*j+j) % 16
			);
	XDrawPoint (display, pixm, theGC, j, i);
      }

  XSetForeground (display, theGC, bg);

  DEBUG2 ("mwinConvertPixmap: End pixm == %s\n", pixm == (Pixmap) 0 ? "NULL" : "OK");

  return 0;
}
#endif

#if 0
int pixmCopy (Window win, int x, int y)
{
  Pixel fg = 1, bg = 0;
  int i, j, l, k;
  static int disp_ = False;
  ulong lclr;
  char ** colors =  pxm_tool_file32_colors;
  int  height = pxm_tool_file32_height;
  int width = pxm_tool_file32_width;
  char ** pixels = pxm_tool_file32_pixels;
  int ncolors = pxm_tool_file32_ncolors;
    

  if (win == 0)
    return;

  for (i=0; i<height; i++)
    for (j=0; j<width; j++)
      {
	lclr = 0;
	for (l=0; l<ncolors; l++)
	  if (pixels[i][j] == colors[l*2][0])
	    {
	      break;
	    }
	if (l<ncolors)
	  {
	    char c;
	    
	    k = 0;
#if 0
	    lclr <<= 3;
	    c = colors[l*2+1][1+k*4];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;	    
#endif
	    lclr <<= 3;
	    c = colors[l*2+1][1+k*4+1];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;
	    
	    k = 1;
#if 0
	    lclr <<= 4;
	    c = colors[l*2+1][1+k*4];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;
#endif
	    lclr <<= 3;
	    c = colors[l*2+1][1+k*4+1];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;
	    
	    k = 2;
#if 0
	    lclr <<= 4;
	    c = colors[l*2+1][1+k*4];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;	    
#endif
	    lclr <<= 3;
	    c = colors[l*2+1][1+k*4+1];
	    if (c > '9') c = c - 'A' + 10; else c -= '0';
	    lclr += c;

	    if (!disp_)
	      {
		DEBUG2 ("0x%x\n", lclr);
		disp_ = True;
	      }
	  }
	else
	  {
	    DEBUG2 ("Pixel (%c) nicht gefunden\n",
		    pixels[i][j]);
	  }

	XSetForeground (display, theGC,
			l<ncolors ? lclr : bg);
	XDrawPoint (display, win, theGC, x+j, y+i);
      }
  return True;
}
#endif	      

int mwinSetPixmapToWidget (Widget wdgt, int index, int mode)
{
#ifdef HAVE_XPM
  XpmAttributes attributes;
  XpmColorSymbol symbols[1];
  Pixel color = 0;
  char ** data;
  Window root;
  unsigned int x, y, bw, bh, depth;
  unsigned int w, h;
  int ret;
  
  if (pxmList[index] <= 0)
    {
	switch (index)
	{
	case PIXM_file16:
	    data = file16_pixm;
	    break;
	case PIXM_file32:
	    data = file32_pixm;
	    break;
	case PIXM_file_archive32:
	    data = file_archive32_pixm;
	    break;
	case PIXM_file_assembler32:
	    data = file_assembler32_pixm;
	    break;
	case PIXM_file_bmp32:
	    data = file_bmp32_pixm;
	    break;
	case PIXM_file_cheader32:
	    data = file_cheader32_pixm;
	    break;
	case PIXM_file_clock32:
	    data = file_clock32_pixm;
	    break;
	case PIXM_file_compr32:
	    data = file_compr32_pixm;
	    break;
	case PIXM_file_core32:
	    data = file_core32_pixm;
	    break;
	case PIXM_file_csource32:
	    data = file_csource32_pixm;
	    break;
	case PIXM_file_devblk16:
	    data = file_devblk16_pixm;
	    break;
	case PIXM_file_devblk32:
	    data = file_devblk32_pixm;
	    break;
	case PIXM_file_devchr16:
	    data = file_devchr16_pixm;
	    break;
	case PIXM_file_devchr32:
	    data = file_devchr32_pixm;
	    break;
	case PIXM_file_disk35zoll32:
	    data = file_disk35zoll32_pixm;
	    break;
	case PIXM_file_disk525zoll32:
	    data = file_disk525zoll32_pixm;
	    break;
	case PIXM_file_Disk_A32:
	    data = file_Disk_A32_pixm;
	    break;
	case PIXM_file_doc1_32:
	    data = file_doc1_32_pixm;
	    break;
	case PIXM_file_doc2_32:
	    data = file_doc2_32_pixm;
	    break;
	case PIXM_file_doc3_32:
	    data = file_doc3_32_pixm;
	    break;
	case PIXM_file_dos32:
	    data = file_dos32_pixm;
	    break;
	case PIXM_file_dosBAT32:
	    data = file_dosBAT32_pixm;
	    break;
	case PIXM_file_dosCOM32:
	    data = file_dosCOM32_pixm;
	    break;
	case PIXM_file_dosEXE32:
	    data = file_dosEXE32_pixm;
	    break;
	case PIXM_file_exec16:
	    data = file_exec16_pixm;
	    break;
	case PIXM_file_exec32:
	    data = file_exec32_pixm;
	    break;
	case PIXM_file_fax32:
	    data = file_fax32_pixm;
	    break;
	case PIXM_file_font32:
	    data = file_font32_pixm;
	    break;
	case PIXM_file_gif32:
	    data = file_gif32_pixm;
	    break;
	case PIXM_file_group32:
	    data = file_group32_pixm;
	    break;
	case PIXM_file_iff32:
	    data = file_iff32_pixm;
	    break;
	case PIXM_file_image32:
	    data = file_image32_pixm;
	    break;
	case PIXM_file_info32:
	    data = file_info32_pixm;
	    break;
	case PIXM_file_iris32:
	    data = file_iris32_pixm;
	    break;
	case PIXM_file_jpeg32:
	    data = file_jpeg32_pixm;
	    break;
	case PIXM_file_link16:
	    data = file_link16_pixm;
	    break;
	case PIXM_file_link32:
	    data = file_link32_pixm;
	    break;
	case PIXM_file_mail32:
	    data = file_mail32_pixm;
	    break;
	case PIXM_file_makefile32:
	    data = file_makefile32_pixm;
	    break;
	case PIXM_file_mouse32:
	    data = file_mouse32_pixm;
	    break;
	case PIXM_file_obj32:
	    data = file_obj32_pixm;
	    break;
	case PIXM_file_package32:
	    data = file_package32_pixm;
	    break;
	case PIXM_file_pbm32:
	    data = file_pbm32_pixm;
	    break;
	case PIXM_file_pcx32:
	    data = file_pcx32_pixm;
	    break;
	case PIXM_file_pipe16:
	    data = file_pipe16_pixm;
	    break;
	case PIXM_file_pipe32:
	    data = file_pipe32_pixm;
	    break;
	case PIXM_file_pm32:
	    data = file_pm32_pixm;
	    break;
	case PIXM_file_ps32:
	    data = file_ps32_pixm;
	    break;
	case PIXM_file_ress32:
	    data = file_ress32_pixm;
	    break;
	case PIXM_file_rle32:
	    data = file_rle32_pixm;
	    break;
	case PIXM_file_sched32:
	    data = file_sched32_pixm;
	    break;
	case PIXM_file_sem16:
	    data = file_sem16_pixm;
	    break;
	case PIXM_file_sem32:
	    data = file_sem32_pixm;
	    break;
	case PIXM_file_sharedobj32:
	    data = file_sharedobj32_pixm;
	    break;
	case PIXM_file_shmem16:
	    data = file_shmem16_pixm;
	    break;
	case PIXM_file_shmem32:
	    data = file_shmem32_pixm;
	    break;
	case PIXM_file_sound32:
	    data = file_sound32_pixm;
	    break;
	case PIXM_file_tape32:
	    data = file_tape32_pixm;
	    break;
	case PIXM_file_term32:
	    data = file_term32_pixm;
	    break;
	case PIXM_file_tiff32:
	    data = file_tiff32_pixm;
	    break;
	case PIXM_file_unknown16:
	    data = file_unknown16_pixm;
	    break;
	case PIXM_file_unknown32:
	    data = file_unknown32_pixm;
	    break;
	case PIXM_file_win32:
	    data = file_win32_pixm;
	    break;
	case PIXM_file_xbm32:
	    data = file_xbm32_pixm;
	    break;
	case PIXM_file_xpm32:
	    data = file_xpm32_pixm;
	    break;
	case PIXM_file_xwd32:
	    data = file_xwd32_pixm;
	    break;
	case PIXM_fldr16:
	    data = fldr16_pixm;
	    break;
	case PIXM_fldr32:
	    data = fldr32_pixm;
	    break;
	case PIXM_fldr_admin32:
	    data = fldr_admin32_pixm;
	    break;
	case PIXM_fldr_appl32:
	    data = fldr_appl32_pixm;
	    break;
	case PIXM_fldr_cdrom32:
	    data = fldr_cdrom32_pixm;
	    break;
	case PIXM_fldr_dev32:
	    data = fldr_dev32_pixm;
	    break;
	case PIXM_fldr_email32:
	    data = fldr_email32_pixm;
	    break;
	case PIXM_fldr_font32:
	    data = fldr_font32_pixm;
	    break;
	case PIXM_fldr_games32:
	    data = fldr_games32_pixm;
	    break;
	case PIXM_fldr_map32:
	    data = fldr_map32_pixm;
	    break;
	case PIXM_fldr_nfs32:
	    data = fldr_nfs32_pixm;
	    break;
	case PIXM_fldr_nfsLocal32:
	    data = fldr_nfsLocal32_pixm;
	    break;
	case PIXM_fldr_nfsMounted32:
	    data = fldr_nfsMounted32_pixm;
	    break;
	case PIXM_fldr_open32:
	    data = fldr_open32_pixm;
	    break;
	case PIXM_fldr_proc_off32:
	    data = fldr_proc_off32_pixm;
	    break;
	case PIXM_fldr_proc_on32:
	    data = fldr_proc_on32_pixm;
	    break;
	case PIXM_fldr_start32:
	    data = fldr_start32_pixm;
	    break;
	case PIXM_fldr_uucp32:
	    data = fldr_uucp32_pixm;
	    break;
	case PIXM_fldr_wb32:
	    data = fldr_wb32_pixm;
	    break;
	case PIXM_host16:
	    data = host16_pixm;
	    break;
	case PIXM_keybd32:
	    data = keybd32_pixm;
	    break;
	case PIXM_kh_on_donkey:
	    data = kh_on_donkey_pixm;
	    break;
	case PIXM_ptool:
	    data = ptool_pixm;
	    break;
	case PIXM_quit24:
	    data = quit24_pixm;
	    break;
	case PIXM_quit32:
	    data = quit32_pixm;
	    break;
	case PIXM_tool_copy24:
	    data = tool_copy24_pixm;
	    break;
	case PIXM_tool_del24:
	    data = tool_del24_pixm;
	    break;
	case PIXM_tool_details24:
	    data = tool_details24_pixm;
	    break;
	case PIXM_tool_draw24:
	    data = tool_draw24_pixm;
	    break;
	case PIXM_tool_edit24:
	    data = tool_edit24_pixm;
	    break;
	case PIXM_tool_execbg24:
	    data = tool_execbg24_pixm;
	    break;
	case PIXM_tool_execwin24:
	    data = tool_execwin24_pixm;
	    break;
	case PIXM_tool_fix24:
	    data = tool_fix24_pixm;
	    break;
	case PIXM_tool_horiz24:
	    data = tool_horiz24_pixm;
	    break;
	case PIXM_tool_large24:
	    data = tool_large24_pixm;
	    break;
	case PIXM_tool_link24:
	    data = tool_link24_pixm;
	    break;
	case PIXM_tool_mkdir24:
	    data = tool_mkdir24_pixm;
	    break;
	case PIXM_tool_move24:
	    data = tool_move24_pixm;
	    break;
	case PIXM_tool_new24:
	    data = tool_new24_pixm;
	    break;
	case PIXM_tool_open24:
	    data = tool_open24_pixm;
	    break;
	case PIXM_tool_parent24:
	    data = tool_parent24_pixm;
	    break;
	case PIXM_tool_print24:
	    data = tool_print24_pixm;
	    break;
	case PIXM_tool_prop24:
	    data = tool_prop24_pixm;
	    break;
	case PIXM_tool_save24:
	    data = tool_save24_pixm;
	    break;
	case PIXM_tool_saveas24:
	    data = tool_saveas24_pixm;
	    break;
	case PIXM_tool_small24:
	    data = tool_small24_pixm;
	    break;
	case PIXM_tool_sortdf24:
	    data = tool_sortdf24_pixm;
	    break;
	case PIXM_tool_sortn24:
	    data = tool_sortn24_pixm;
	    break;
	case PIXM_tool_vert24:
	    data = tool_vert24_pixm;
	    break;
	case PIXM_tool_abort48:
	    data = tool_abort48_pixm;
	    break;
	case PIXM_tool_abortd48:
	    data = tool_abortd48_pixm;
	    break;
	case PIXM_tool_stop48:
	    data = tool_stop48_pixm;
	    break;
	case PIXM_tool_run48:
	    data = tool_run48_pixm;
	    break;
	case PIXM_tool_xkhfm24:
	    data = tool_xkhfm24_pixm;
	    break;

	case PIXM_tool_add24:
	  data = tool_add24_pixm;
	  break;
	case PIXM_tool_addd24:
	  data = tool_addd24_pixm;
	  break;
	case PIXM_tool_mod24:
	  data = tool_mod24_pixm;
	  break;
	case PIXM_tool_modd24:
	  data = tool_modd24_pixm;
	  break;
	case PIXM_tool_dele24:
	  data = tool_dele24_pixm;
	  break;
	case PIXM_tool_deled24:
	  data = tool_deled24_pixm;
	  break;
	case PIXM_tool_cpy24:
	  data = tool_cpy24_pixm;
	  break;
	case PIXM_tool_cpyd24:
	  data = tool_cpyd24_pixm;
	  break;
	case PIXM_tool_paste24:
	  data = tool_paste24_pixm;
	  break;
	case PIXM_tool_pasted24:
	  data = tool_pasted24_pixm;
	  break;
	case PIXM_tool_undo24:
	  data = tool_undo24_pixm;
	  break;
	case PIXM_tool_undod24:
	  data = tool_undod24_pixm;
	  break;
	case PIXM_tool_find24:
	  data = tool_find24_pixm;
	  break;
	case PIXM_tool_grep24:
	  data = tool_grep24_pixm;
	  break;


	case PIXM_tree_dir16:
	    data = tree_dir16_pixm;
	    break;
	case PIXM_tree_odir16:
	    data = tree_odir16_pixm;
	    break;
	case PIXM_win32:
	    data = win32_pixm;
	    break;
	default:
	    data = file32_pixm;
	    break;
	}

	memset (&attributes, 0, sizeof (attributes));
	memset (&symbols[0], 0, sizeof (symbols[0]));

	XtManageChild (wdgt);
        color = -1;
	XtVaGetValues (wdgt, XmNbackground, &color, NULL);
	if (color == -1)
	  XtVaGetValues (XtParent(wdgt), XmNbackground, &color, NULL);
	
	DEBUG4 ("mwinCrPixmaps: color=[%u][0x%x][%b]\n", color, color, color);

	symbols[0].name  = NULL;
	symbols[0].value = data[1] + 4;
	symbols[0].pixel = color;
	attributes.numsymbols   = 1;
	attributes.colorsymbols = symbols;
	attributes.valuemask = XpmColorSymbols ;
	
	ret = XpmCreatePixmapFromData(display,
				      rootWindow,
				      data,
				      &pxmList[index],
				      NULL,
				      &attributes);
	if (ret == XpmColorFailed)
	{
	  attributes.colormap = XCreateColormap(display,
    			       rootWindow,
			       DefaultVisual(display, DefaultScreen(display)),
			       AllocNone);
	  attributes.valuemask |= XpmColormap;
	  ret = XpmCreatePixmapFromData(display,
			     		rootWindow,
			     		data,
			     		&pxmList[index],
			     		NULL,
			     		&attributes);
	}
	if (ret != XpmSuccess)
	    {
		ERROR2 ("mwinCrPixmaps: %s\n", XpmGetErrorString(ret));
		exit(1);
	    }
	if (!XGetGeometry (display, pxmList[index],
			   &root, &x, &y, &w, &h, &bw, &depth))
	  {
	    WARNING2 ("mwinCrPixmaps: cannot get geometry "
		      "for pixmap number (%i)\n", index);
	    pxmWidth [index] = 32;
	    pxmHeight[index] = 32;
	  }
	else
	  {
	    pxmWidth [index] = w;
	    pxmHeight[index] = h;
	  }
    }
#endif /* HAVE_XPM */

  if (mode & MWIN_LOADANDSET)
    XtVaSetValues (wdgt,
		   XmNlabelType,   XmPIXMAP,
		   XmNlabelPixmap, pxmList[index],
		   NULL);
  else if (mode & MWIN_DISABLED)
    XtVaSetValues (wdgt,
		   XmNlabelType,   XmPIXMAP,
		   XmNlabelInsensitivePixmap, pxmList[index],
		   NULL);
}
