/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: mwinTitle.c,v 1.1 1996/10/28 03:35:30 khamis Exp khamis $
 * $Source: /home/xkhfm/xkhlib/xkhsrc/RCS/mwinTitle.c,v $
 */
#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include <sys/param.h>
#include "Xinc.h"

#include "defines.h"
#include "mainwin.h"
#include "version.h"

void mwinTitle (Mainwin_t mwin)
{
  char tmp [MAXPATHLEN + sizeof (PROGRAM_NAME) + 5];
  int have_filter = strcmp (mwin->DirFilter, "*");

  if (mwin->shlMainwin == NULL)
    return;

  DEBUG1 ("mwinTitle");

  sprintf (tmp, "%s%s%s %s [%s%s%s]",
	   UserName != NULL ? UserName : "",
	   UserName != NULL ? "@" : "",
	   Hostname != NULL ? Hostname : "",
	   PROGRAM_NAME,
	   mwin->DirName,
	   have_filter ? "/" : "",
	   have_filter ? mwin->DirFilter : "");

  SetWindowTitle (mwin->shlMainwin, tmp);
  XtVaSetValues  (mwin->shlMainwin,
		  XtNiconName, tmp,
		  NULL);

  DEBUG2 ("mwinTitle: (%s) Ende\n", mwin->DirName);
}
