/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: quit.c,v 1.1 1997/01/07 08:36:58 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhsrc/RCS/quit.c,v $
 */
#define IS_EXTERN
#define EXTERN			extern

#include <stdio.h>
#include <stdlib.h>

#include "Xinc.h"		/* XIncludes mit enthalten */
#include "Umessage.h"
#include "quit.h"

void SaveHelpCB (void)
{
  hlpDest (HelpWindow);
  exit (0);
}

void SaveAndExitCB (void)
{
  /****** Hilfefenster schliessen und evtl. speichern *************************/
  if (HelpWindow != NULL && HelpWindow->WriteFlagg)
    {
      MessageBox
	(NULL,
	 "Hilfe speichern",
	 "Hilfe wurde geaendert, wollen Sie die Aenderungen speichern ?!",
	 XmDIALOG_QUESTION,
	 OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON,
	 (void (*) (void)) SaveHelpCB,  /* Hilfe speichern ********************/
	 NULL);
    }
  else
    exit (0);
}

void Quit (Widget w, Widget shell)
{
  MessageBox (shell,
	      "Programmende",
	      "Wollen Sie wirklich das Programm Verlassen ?",
	      XmDIALOG_QUESTION,
	      OK_BUTTON | CANCEL_BUTTON | HELP_BUTTON,
	      (void (*) (void)) SaveAndExitCB,
	      NULL);
}




