/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: docdrom.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/docdrom.h,v $
 */

#ifndef DOCDROM_HH
#	define DOCDROM_HH

#ifdef HAVE_CDROM

#include "dodefs.h"
#include "doglobal.h"

/*
 * it must the correct cdrom, do you need 
 */
#define CDROM_DEV "/dev/rcdrom/c1t1l0" 
#define FIRST_TRACK 1

/*
 * Ugly kludge which everyone needs, one per program
 */
#ifdef EXTERN
EXTERN int trackProgram [99];
#else
int trackProgram        [99]={1,2,3,4,5,6,7,8,9, \
 			  16,17,18,19,20,21,22,23,24,25, \
			  32,33,34,35,36,37,38,39,40,41, \
			  48,49,50,51,52,53,54,55,56,57, \
			  64,65,66,67,68,69,70,71,72,73, \
			  80,81,82,83,84,85,86,87,88,89, \
			  96,97,98,99,100,101,102,103,104,105, \
			  112,113,114,115,116,117,118,119,120,121, \
			  128,129,130,131,132,133,134,135,136,137, \
			  144,145,146,147,148,149,150,151,152,153};
#endif
int cdrom_open 		(char * cdrom_dev);
int cdrom_close 	(int cdrom);
int cdrom_stop 		(int cdrom);
int cdrom_Tracks 	(int cdrom);
int cdrom_eject 	(int cdrom);
int cdrom_play 		(int cdrom, int trackNum);
int cdrom_pause 	(int cdrom);
int cdrom_resumePlay 	(int cdrom);

#endif		/* HAVE_CDROM */

#endif	/* HH */
