/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: docfg.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/docfg.h,v $
 */

#ifndef DOCFG_HH
#	define DOCFG_HH

#include "dodefs.h"
#include "doscr.h"
#include "dowin.h"

#define TITLE_SIZE	128
#define DATE_SIZE	32
#define TIME_SIZE	16
#define HEAD_SIZE	32


struct MY_cfg_t {
    char title		[TITLE_SIZE];		/* TITLE for projekct */
    char date 		[DATE_SIZE];		/* date of conf.file */
    char time 		[TIME_SIZE];		/* time */

    char cfg_file	[MAXPATH];
    char edit_file	[81];

    int  max_file_cnt;
    int  win_cnt;
    int  akt_w;

    int  help_line_hidden;

    int  stern_timeout;
    int  stern_active;
    int  auto_save;

    /* window coordinates */
    int  def_x		[MAX_WIN];
    int  def_y		[MAX_WIN];
    int  def_width	[MAX_WIN];
    int  def_deep	[MAX_WIN];
    int  def_view	[MAX_WIN];
    int  def_outbegin	[MAX_WIN];
    int  def_mode	[MAX_WIN];
    int  def_anf_pos    [MAX_WIN];
#ifdef DOS
    int  def_drive      [MAX_WIN];
#endif
    char def_path	[MAX_WIN][MAXPATH];
    char def_file	[MAX_WIN][MAXPATH];

    char options	[OPT_CNT][OPT_LEN];
    int  colors  	[CLR_CNT];
    };

typedef struct MY_cfg_t * MY_cfg_T;

#ifdef EXTERN
GLOBAL struct MY_cfg_t MY_cfg;
#else
GLOBAL struct MY_cfg_t MY_cfg;
#if 0
 = 
	{
	"Khamis Utilities",
	"date",
	"time",
	"cfg_file",
	"edit_file",
	MAX_FILE_CNT,
	2,
	0,
	FALSE,
	60,
	TRUE,
	TRUE,
	{ 0, 40, 0 },
	{ 1, 1, 0},
	{ 39, 39, 0},
	{ 11, 11, 0},
	{ TRUE, TRUE, FALSE},
	{ 0, 0, 0},
	{ VIEW_MODE, VIEW_MODE},
	{ 1, 1},
#ifdef DOS
	{ 2, 2},
#endif
	{ ".", "." },
	{ "..", ".." },
	{ "", ""},
	{ 0
/*
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
*/
 	} 
	};
#endif
#endif

GLOBAL void save_config	(MY_cfg_T cofig);
GLOBAL void load_config	(MY_cfg_T cofig);
GLOBAL void read_config (MY_cfg_T config);
GLOBAL void MY_setup    (MY_cfg_T cofig);

#endif /*DOCFG_HH*/

