/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: doerror.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/doerror.c,v $
 */

#define GLOBAL extern
#define EXTERN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#ifdef UNIX
#include <termio.h>
#endif

#include "doglobal.h"
#include "dostring.h"
#include "dolib.h"
#include "docfg.h"
#include "doscr.h"
#include "doerror.h"

void buserror( int code) {
    PER( "Fatal error: bad Memory cache\n");
    quit( code);
    }

void want_quit (int code) {
    int old_cursor = cur_hidden,
	old_x = cur_x,
	old_y = cur_y;

    if( Getyesno (" EXIT, are you sure ?! ",
	       " Exit ;; Break ",
	       leer, -1
	       )
       == 0
       )
      quit (0);

    signal (code, want_quit);

    if (!old_cursor) view_cursor();
    gotoXY (old_x, old_y);
    }

void quit( int code) {

	view_cursor();
	setattr( F_B_GROUND_CLR);

#ifdef UNIX

	SET_TTY( &oldtty);

#ifdef MOUSE
	if( mouse_mode) ev_close();		/* close the event */
#endif

#endif

	fflush_();

	if (code != 0) exit( code);             /* an error is expected */

	if (MY_cfg.auto_save) save_config(&MY_cfg);
	clrscr_();
	fflush_();
/*
	copyright();
*/
	exit( code);
	}

