/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: khhexa.c,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khfm/RCS/khhexa.c,v $
 */

#	define GLOBAL

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>

#include <time.h>
#include <sys/timeb.h>
#include <malloc.h>
#include <fcntl.h>

#ifdef UNIX

#include <termio.h>
#include <string.h>
#include <sys/types.h>
#include <grp.h>
#include <pwd.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/sysmacros.h>
#ifdef SCO_UNIX
#include <sys/page.h>
#include <sys/event.h>
#endif

#ifdef SCO_UNIX
#include <tinfo.h>		/* KEY_NUMBER is defined in this file */
#include <sys/console.h>
#include <mouse.h>
#endif

#include <curses.h>

#else			/* ifdef UNIX */

#include <dos.h>
#include <conio.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#endif

#include "dodefs.h"
#include "doglobal.h"
#include "dolib.h"
#include "dowin.h"
#include "doscr.h"
#include "docfg.h"
#include "doabout.h"
#include "dochoose.h"
#include "docrypt.h"
#include "dodirent.h"
#include "doedit.h"
#include "dofiles.h"
#include "dofind.h"
#include "doframe.h"
#include "dogrep.h"
#include "dohexa.h"
#include "doinit.h"
#include "domem.h"
#include "domenu.h"
#include "domsg.h"
#include "dostat.h"
#include "dostern.h"
#include "dostring.h"
#include "dotcap.h"
#include "dotext.h"
#include "doutil.h"
#include "doqsort.h"
#include "doerror.h"
#include "dostern.h"
#include "dofiles.h"
#include "domem.h"
#include "dogrep.h"
#include "dotext.h"
#include "doabout.h"
#include "docfg.h"
#include "dohist.h"
#include "dofind.h"
#include "dodir.h"
#include "docdrom.h"
#include "docopy.h"


void hexa_usage( char * prg) {
    fprintf( stderr, "Usage: %s <file>\n", prg);
    }

void main( int argc, char * argv[]) {
    int i;
    char * f_name;

    argc_ = argc;
    argv_ = argv;

    strcpy( prog_path, argv[0]);

    if( argc < 2) {
	hexa_usage( argv[0]);
	exit( 1);
	}

    f_name = argv[1];			/* file name */

    for(i=1; i<argc; i++) argv[i] = argv[i+1];
    argc = argc_ = argc - 1;

    init_values(&MY_cfg);

    f_putstr( title_f, 0, 0,
	      " Khamis Hexa Editor Version 1.0, CopyRight 1994",
	      title_f->color, NOMODE);
    view_frame( title_f);

    hexa_editor( f_name, FALSE);
    quit( 0);
    }
