/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=cnfutil.h, SID=1.1, Date=95/09/20 */

/****************************************************************************/
/**                  							   **/
/****************************************************************************/

#ifndef CNFUTIL_HH
#	define CNFUTIL_HH

#ifndef MAXLEN_CNFLINE
#define MAXLEN_CNFLINE  (1024*8)
#endif

#define CNF_MAXLINELEN	(1024*8)
#define CNF_MAXPARAMLEN 256

typedef struct
{
  int    FileDesc;
  int    FileMode;
  int    FileSize;
  int    CurrentPos;
  int    WriteFlag;
  char   Comment;		/* Kommentarzeichen */
  char   LineAppend;		/* Verbindungszeichen fuer naechste Zeile */
  char   Trennz [2];
  char   Filename [MAXPATHLEN];
  char * FileEntry;
} conf_t, * Conf_t;

Conf_t confOpen       (char * confFile, char * title);
int    confClose      (Conf_t);
int    confWrite      (Conf_t, char trennz, char * section, int argc, char * argv[]);
char * confRead       (Conf_t, char trennz, char * section, char * param);
int    confAddSection (Conf_t, char * section);
int    confDelSect    (Conf_t cnf, char * section);
int    confAppend     (Conf_t cnf, char trennz, char * section, int argc, char*argv[]);
char * confReLine     (Conf_t cnf, int mode);
int    confDelToEnd   (Conf_t cnf, int pos);


EXTERN int	ConfigWrite      (char * ConfigFile, char trennz,
			  char * section, int argc, char* argv[]);
EXTERN char *	ConfigRead	 (char * ConfigFile, char trennz,
				  char * section,
				  char * param);

EXTERN long	ConfigSectionPos (int fdesc, char * section);
EXTERN int	ConfigAddSection (int fdesc, char * section);
EXTERN char *	ConfigReadLine   (int fdesc);

#endif

