/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=Udchain.h, SID=1.4, Date=95/10/18 */

#ifndef DCHAIN_H
#define DCHAIN_H

#ifndef True
#define True	1
#define False	0
#endif

#define MAXPNAME		32

/********* Listen-Struktur der vorhandenen parameter, diese Parameter werden **/
/********* in eine einfach verkettete Liste eingelegt *************************/
struct dchain_tt
{
  void * client;
  struct dchain_tt * next, * prev;
};

typedef struct dchain_tt dchain_t , * Dchain_t;

/********* Funktionen fuer die Parameterliste *********************************/
#define   UdchNext(p)	((p)->next)
#define   UdchPrev(p)	((p)->prev)
#define   UdchClient(p) ((p) != NULL ? ((p)->client) : NULL)

/*
EXTERN void *	  UdchClient	(Dchain_t lst);
*/

EXTERN int       UdchCopy      (Dchain_t item,
				void * data,
				int (* ClCopy) (void *, void *));
EXTERN Dchain_t  UdchMake      (void * data, void * (* ClMake) (void *));
EXTERN int       UdchDestroy   (Dchain_t, int (* ClDelete) (void *));
EXTERN Dchain_t  UdchAdd       (Dchain_t top,
				void * data,
				void * (* ClMake) (void *),
				int    (* ClCompare) (void *, void *));

EXTERN int       UdchEmpty       (Dchain_t top, int (* ClDelete) (void *));
EXTERN int       UdchDelete      (Dchain_t, int (* ClDelete) (void *));
EXTERN int       UdchEmptyAndDel (Dchain_t top, int (* ClDelete) (void *));

EXTERN Dchain_t  UdchFind      (Dchain_t top,
				void * data,
				int (* ClCompare) (void *, void *));
EXTERN Dchain_t  UdchTop       (Dchain_t lst);
EXTERN Dchain_t  UdchLast      (Dchain_t lst);
EXTERN int       UdchCount     (Dchain_t top);
EXTERN int       UdchPos       (Dchain_t top, Dchain_t lst);
EXTERN int       UdchItemExists(Dchain_t top,
				void * data,
				int (* ClCompare) (void *, void *));
EXTERN int       UdchChange    (Dchain_t top,
				Dchain_t liste,
				void * newValue,
				int    (* ClChange ) (Dchain_t, void*),
				int    (* ClCompare) (void*, void*));
/*
EXTERN Dchain_t  UdchInsert    (Dchain_t top,
                                void * data,
			        void * (* ClMake  ) (void *),
			        int    (* ClCompare) (void *, void *));
*/
#endif

