/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/* Funktionsname=mem.h, SID=1.3, Date=95/09/19 */

/******************************************************************************/
/*                                                                            */
/* Strukturen:                                                                */
/*                                                                            */
/* keine								      */
/*                                                                            */
/* Funktionen:                                                                */
/*                                                                            */
/******************************************************************************/

#ifndef MEM_H
#define MEM_H

#if defined (DEBUG) && ! defined (DEBUG_VIEWMEM)
#define DEBUG_VIEWMEM
#endif

#ifdef DEBUG_VIEWMEM

#ifdef IS_EXTERN
EXTERN long bufUsage;
#else
long bufUsage = 0;
#endif

void ViewMemUsage (void*, void*);
int MFree (void*ptr, int size);
void * gmalloc (long size, int line, char * file);
void * gcalloc (long size, int line, char * file);

#else
#define MFree(ptr, size) free (ptr);
void* GMalloc (unsigned long size);
void* GCalloc (unsigned long size);
#define gmalloc(size,line,file) GMalloc(size)
#define gcalloc(size,line,file) GCalloc(size)
#endif


#endif
