/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: remove.h,v 1.1 1997/01/07 08:39:42 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/khlib/include/RCS/remove.h,v $
 */
/* Funktionsname=%M%, SID=%I%, Date=%E% */

#ifndef REMOVE_H
#define REMOVE_H

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <fcntl.h>

#define REM_ASK		0x0001
#define REM_RECURSIVE	0x0002
#define REM_CANCEL	0x0004
#define REM_ALL		0x0008
#define REM_YES		0x0010
#define REM_NO		0x0020
#define REM_EMPTY_DIR	0x0040

#define REM_ERROR_AVAIL	0x4000

int RecursiveRemove (char * file,
		     char * RemFilter,
		     char * DonotRemFilter,
		     unsigned long (* ViewState) (char *, void*),
		     unsigned long (* AskProc)   (char *, void*),
		     unsigned long (* ErrProc)   (char *, void*),
		     unsigned long mode,
		     void * ClData);

#endif
