/************************************************************************
 *  (C)opyright 1996/1997 by Khamis Abu El-Komboz                       *
 *  xkhfm 1.0 can be copied and distributed freely for any              *
 *  non-commercial purposes. xkhfm can only be incorporated             *
 *  into commercial software with the permission of the current author. *
 *  Mail: khamis@multix.de                                              *
 ************************************************************************/
/*
 * $Author: khamis $
 * $Id: scale.c,v 1.1 1997/01/07 08:38:27 khamis Exp $
 * $Source: /home/khamis/source/xkhfm/xkhlib/xkhmisc/RCS/scale.c,v $
 */

#define IS_EXTERN
#define EXTERN		extern

#include <stdio.h>
#include <stdlib.h>
#include "Xinc.h"

#include "defines.h"
#include "about.h"
#include "quit.h"
#include "Umenu.h"
#include "Uxutil.h"

Widget sclMake (Widget parent,
		char * label,
		int minValue, int maxValue,
		char * MesgArea,
		int mode)
{
  Widget scale;

#if 0
  DEBUG2 ("sclMake: (%s)\n", label);
#endif

  scale = XtVaCreateManagedWidget (label, 
				   xmScaleWidgetClass,
				   parent,
				   /*
				   XtVaTypedArg, XmNtitleString,
				   XmRString,    label,
				   6,
				   */
				   XmNorientation,
				   (mode) ? XmVERTICAL : XmHORIZONTAL,
				   XmNmaximum,	maxValue,
				   XmNminimum,	minValue,
				   /*XmNvalue,	50,*/
				   XmNshowValue,	True,
				   NULL);
  sclMesgArea   (scale, MesgArea);
  XtManageChild (scale);

#if 0
  DEBUG1 ("sclMake: Ende");
#endif

  return scale;
}
